package com.flooded;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;


import com.facebook.model.GraphUser;
import com.facebook.Request;
import com.facebook.Response;
import com.facebook.Session;
import com.facebook.SessionState;
import com.facebook.UiLifecycleHelper;
import com.flooded.helperClasses.FriendListItem;
import com.flooded.helperClasses.ImageLoadData;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.util.SparseArray;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class FriendsActivity extends Activity {
	

	private UiLifecycleHelper uiHelper;
	  
	  
//	  private Session.StatusCallback callback = new Session.StatusCallback() {
//		    @Override
//		    public void call(Session session, SessionState state, Exception exception) {
//		        onSessionStateChange(session, state, exception);
//		    }
//		};
	
	  @Override
	  public void onActivityResult(int requestCode, int resultCode, Intent data) {
	      super.onActivityResult(requestCode, resultCode, data);
	      Session.getActiveSession().onActivityResult(this, requestCode, resultCode, data);
	  }
	  
	  
	
	
	 private ListView mFriendsList;
	 
	 public static final String TAG = "FBTask";
	 private void toast(String message) {
	     	Toast.makeText(
	     			getApplicationContext(),
	     			message,
	     			Toast.LENGTH_SHORT).show();
	     }

	@Override
	public void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		 setContentView(R.layout.friends_list);
		mFriendsList = (ListView) findViewById(R.id.friends_list);
	    uiHelper = new UiLifecycleHelper(this,  null);
	    uiHelper.onCreate(savedInstanceState);
	    
	       Session.openActiveSession(this, true, null); 
		requestFriends();
	}

	
    
			@Override
			public boolean onCreateOptionsMenu(Menu menu) {
			    MenuInflater inflater = getMenuInflater();
			    inflater.inflate(R.menu.friend_menu2, menu);
			    return true;
			}
			
			@Override
			public boolean onOptionsItemSelected(MenuItem item) {
			    switch (item.getItemId()) {
			        case R.id.menutext6:   finish();
			        						break;
			      
			    }
			    return true;
			}
	
	  /**
	  +     * Requests friend list of the current user from the facebook.
	  +     */
	      private void requestFriends() {
	    	  Session session = Session.getActiveSession();
	     	Request request = Request.newMyFriendsRequest(session, new Request.GraphUserListCallback() {
	  			public void onCompleted(List<GraphUser> users, Response response) {
	  				if (response.getError() == null)
	  				{
	  					ArrayList<FriendListItem> items = new ArrayList<FriendListItem>();
	  					for (GraphUser user : users) {
	  						items.add(
	  								new FriendListItem(user.getId(), user.getName())
	  						);
	  					}
	  					mFriendsList.setAdapter(new FriendListAdapter(FriendsActivity.this, R.id.friends_list, items));
	  					
	  					//toast("Friend list loaded! ("+ items.size() +")");
	  				}
	  				else
	  				{
	  					Log.e(FriendsActivity.TAG, "Friends request: " + response.getError().getErrorMessage());
	  					toast("Friend list request failed!");
	  					toast(response.getError().getErrorMessage());
	  				}
	  			}
	      	});
	      	Request.executeBatchAsync(request);
	  	}
	      
	      /** Adapter class for the ListView that shows the friends. */
          private class FriendListAdapter extends ArrayAdapter<FriendListItem> {

        	  
        	  public static final String TAG = "FBTask";
        	  
          	/** List of items in the ListView */
      		private List<FriendListItem> listItems;
      		
      		/** Used to keep track of loaded images
      		 * (For some reason, it seems to keep loading the image over and over again, if
      		 * we don't keep track of it our selves. Testing item.getBitmap() == null should
      		 * suffice, but it still keeps reloading the images whenever getView is called.)
      		 */
      		private SparseArray<Boolean> readyItems = new SparseArray<Boolean>();
      		
      		/** Initialize the adapter with the list of items */
      		public FriendListAdapter(Context context, int resource, List<FriendListItem> items) {
      			super(context, resource, items);
      			this.listItems = items;
      			for (int i = 0; i < listItems.size(); i++) {
      	            listItems.get(i).setAdapter(this);
      	        }
      		}
      		

      		boolean isItemReady(int position) {
      			Boolean ready = readyItems.get(position);
      			return (ready != null && ready == true);
      		}
      		
      		void setItemReady(int position, boolean ready) {
      			readyItems.put(position, ready);
      		}
      		
      		/** Called once per item whenever the list needs to be refreshed */
      				@Override
      			    public View getView(int position, View convertView, ViewGroup parent) {
      			        View view = convertView;
      			        if (view == null) {
      			            LayoutInflater inflater =
      			                    (LayoutInflater) FriendsActivity.this
      			                    .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
      			            view = inflater.inflate(R.layout.list_item, null);
      			        }
      		
      			        FriendListItem item = listItems.get(position);
      			        item.setPosition(position);
      			        if (item != null) {
      			        	if (item.getBitmap() == null && !isItemReady(position))
      			        	{
      			        		loadBitmap(item);
      			        	}
      			        	
      			            ImageView icon = (ImageView) view.findViewById(R.id.icon);
      			            TextView text = (TextView) view.findViewById(R.id.name);
      			            TextView info = (TextView) view.findViewById(R.id.onlinestatus);
      			            if (icon != null) {
      			            	icon.setImageBitmap(item.getBitmap());
      			            	
      				        	if (!isItemReady(position))
      				        	{
      				        		setItemReady(position, true);
      				        	}
      			            }
      			            if (text != null) {
      			                text.setText(item.getName());
      			            }
      			            if (info != null){
      			            	info.setText("");
      			            }
      			        }
      			        return view;
      			    }
      

		/** Loads the bitmap for the item or gets it from the cache. */
		private void loadBitmap(FriendListItem item) {
			
			
				ProfileImageLoader imageLoader = new ProfileImageLoader();
				ImageLoadData data = new ImageLoadData();
	        	data.setListItem(item);
	        	
	        	URL url;
				try {
					url = new URL("http", "graph.facebook.com", "/" + item.getId() + "/picture?type=small");
		        	data.setUrl(url);
		        	imageLoader.execute(data);
				} catch (MalformedURLException e) {
			
				}
			
		}
      				
      				
      				 private class ProfileImageLoader extends AsyncTask<ImageLoadData, Void, ImageLoadData> {
     		         	
     		         	/** Loads the bitmap from facebook */
     		 			@Override
     		 			protected ImageLoadData doInBackground(ImageLoadData... params) {
     		 			ImageLoadData data = params[0];
     		 				
     		 	        	URL url = data.getUrl();
     		 				try {
     		 		        	Bitmap bm = BitmapFactory.decodeStream(url.openConnection().getInputStream());
     		 		        	data.setBitmap(bm);
     		 				} catch (IOException e) {
     		 					Log.w(FriendsActivity.TAG, "Could not retrieve profile image!");
     		 				}
     		         	
     		 				return data;
     		 			}
     		 			
     		 			/** After loading, sets the bitmap to the corresponding item */
     		 			@Override
     		 			protected void onPostExecute(ImageLoadData result) {
     		 				if (result == null) return;
     		 				super.onPostExecute(result);
     		 				
     		 				Bitmap bitmap = result.getBitmap();
     		 				FriendListItem item = result.getListItem();
     		 				
     		 				item.setBitmap(bitmap);
     		 				
     		 				
     		 				String msg = "Image to list position " + item.getPosition() + " for " + item.getName() + " loaded.";
     		 				
     		 			}
     		         	
     		         }        
     		 		
     		     }	
      		
}
	      
	      
	  

	

