package com.flooded;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import com.JSONParser.PlayerResponse;
import com.JSONParser.PlayerHolder;
import com.facebook.model.GraphUser;
import com.facebook.Request;
import com.facebook.Response;
import com.facebook.Session;
import com.flooded.helperClasses.FriendListItem;
import com.flooded.helperClasses.HTTPHandler;
import com.flooded.helperClasses.Helper;
import com.flooded.helperClasses.ImageLoadData;

import com.google.gson.Gson;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.DialogInterface.OnCancelListener;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.os.AsyncTask;
import android.os.Bundle;
import android.text.Editable;
import android.util.Log;
import android.util.SparseArray;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class GameFriendsActivity extends Activity {
	  
	 private ListView mFriendsList;
	 ImageView friendPic;
	 private ArrayList<String> gamerfriends;
	 private ArrayList<String> tempstatus;
	 private ArrayList<String> onlinestatus;
	 ProgressDialog progressDialog;
	 String toPerson;
	 String playerID;
	 private boolean tutorial;
	 private HTTPHandler httphandler;

	Editable editable;
	static final int GET_MESSAGE_TUTORIAL = 1;
	 public static final String TAG = "FBTask";
	 private void toast(String message) {
	     	Toast.makeText(
	     			getApplicationContext(),
	     			message,
	     			Toast.LENGTH_SHORT).show();
	     }

	  @Override
	  public void onActivityResult(int requestCode, int resultCode, Intent data) {
	      super.onActivityResult(requestCode, resultCode, data);
	      Session.getActiveSession().onActivityResult(this, requestCode, resultCode, data);
	  }
	  
	 
	@Override
	public void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		 setContentView(R.layout.friends_list);
		mFriendsList = (ListView) findViewById(R.id.friends_list);
		tutorial = getIntent().getBooleanExtra("tutorial", false);
		   playerID = getIntent().getStringExtra("fbid");
		   httphandler = new HTTPHandler();
		Session.openActiveSession(this, true, null);
		// fetch list of Facebook friends that has the game
		getFriends();

	}

	
	void getFriends() {
	  	
	  	progressDialog = ProgressDialog.show(this,
	      		"Please wait...", "Retrieving data...", true, true);

	  	FriendsAsyncTask task = new 	FriendsAsyncTask();
	  	task.execute();
	  	progressDialog.setOnCancelListener(new CancelListener(task));		
	  }
	  
	  private class FriendsAsyncTask extends AsyncTask<Void, Void, Void> {

	  	PlayerResponse playerResponse;

			@Override
			protected Void doInBackground(Void... params) {

				String url ="";
				
				url = "http://sondre.mannsverk.no/restful.php";
				
	  		HttpGet getRequest = new HttpGet(url);
	  		
	  		try {
	  			DefaultHttpClient httpClient = new DefaultHttpClient();
	  			HttpResponse getResponse = httpClient.execute(getRequest);
	  			
	  			final int statusCode = getResponse.getStatusLine().getStatusCode();
	  			
	  			if (statusCode != HttpStatus.SC_OK) { 
	  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
	  	            return null;
	  	        }

	  			HttpEntity getResponseEntity = getResponse.getEntity();
	  			InputStream httpResponseStream = getResponseEntity.getContent();
	  			Reader inputStreamReader = new InputStreamReader(httpResponseStream);
	  			
	              Gson gson = new Gson();
	              this.playerResponse = gson.fromJson(inputStreamReader, PlayerResponse.class);
	  		} 
	  		catch (IOException e) {
	  			getRequest.abort();
	  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
	  		}

				return null;
			}
			
			@Override
			protected void onPostExecute(Void result) {
				super.onPostExecute(result);
				
				//StringBuilder builder = new StringBuilder();
				
				gamerfriends = new ArrayList<String>();
				onlinestatus = new ArrayList<String>();
				tempstatus = new ArrayList<String>();
				
				boolean internetConnection = false;
			
				
				try{
					
				
			
				
				for (PlayerHolder player : this.playerResponse.data) {
						gamerfriends.add(player.getFbid());
						tempstatus.add(player.getOnline());
					}
		
				internetConnection = true;
				}
				catch(NullPointerException e){
					Helper.displayText("No internet connection!", getBaseContext(), true);
					e.printStackTrace();
					
				}
				
				progressDialog.cancel();
				
				if(internetConnection){
					requestFriends();	
				}
			}
	  	
	  }
	  
	
	  /*
	       * Requests friends from the current user from the facebook that has the application.
	       */
	
	      private void requestFriends() {
	    	  
	    	  Session session = Session.getActiveSession();
	     	Request request = Request.newMyFriendsRequest(session, new Request.GraphUserListCallback() {
	  			public void onCompleted(List<GraphUser> users, Response response) {
	  				if (response.getError() == null)
	  				{
	  					
	  					ArrayList<FriendListItem> items = new ArrayList<FriendListItem>();
	  					for (GraphUser user : users) {
	  					
	  						for(int i = 0; i < gamerfriends.size(); i++){
	  							if(user.getId().equals(gamerfriends.get(i))){
	  								items.add(new FriendListItem(user.getId(), user.getName()));
	  								onlinestatus.add(tempstatus.get(i));
	  							}
	  						}
	  					}
	  					
	  					if(items.size() == 0){
	  						items.add(new FriendListItem("1033805654", "Sondre Mannsverk"));
	  						onlinestatus.add("0");
	  					}
	  					
	  					mFriendsList.setAdapter(new FriendListAdapter(GameFriendsActivity.this, R.id.friends_list, items));
	  					
	  				}
	  				else
	  				{
	  					Log.e(FriendsActivity.TAG, "Friends request: " + response.getError().getErrorMessage());
	  					toast("Friend list request failed!");
	  					toast(response.getError().getErrorMessage());
	  				}
	  			}
	      	});
	      	Request.executeBatchAsync(request);
	  	} // end requestFriends
	      
	      
	      
	 
//	      
//			@Override
//			public boolean onCreateOptionsMenu(Menu menu) {
//				if(!tutorial){
//				    MenuInflater inflater = getMenuInflater();
//				    inflater.inflate(R.menu.friend_menu, menu);
//				}
//			    return true;
//			}
//			
//			@Override
//			public boolean onOptionsItemSelected(MenuItem item) {
//			    switch (item.getItemId()) {
//			        case R.id.menutext5:   Intent intent = new Intent(GameFriendsActivity.this, FriendsActivity.class);
//			        						startActivity(intent);
//			        						break;
//			      
//			    }
//			    return true;
//			}
	      
	      /** Adapter class for the ListView that shows the friends. */
          private class FriendListAdapter extends ArrayAdapter<FriendListItem> {

        	  public static final String TAG = "FBTask";
        	  
          	/** List of items in the ListView */
      		private List<FriendListItem> listItems;
      		
      		/** Used to keep track of loaded images
      		 * (For some reason, it seems to keep loading the image over and over again, if
      		 * we don't keep track of it our selves. Testing item.getBitmap() == null should
      		 * suffice, but it still keeps reloading the images whenever getView is called.)
      		 */
      		private SparseArray<Boolean> readyItems = new SparseArray<Boolean>();
      		
      		/** Initialize the adapter with the list of items */
      		public FriendListAdapter(Context context, int resource, List<FriendListItem> items) {
      			super(context, resource, items);
      			this.listItems = items;
      			for (int i = 0; i < listItems.size(); i++) {
      	            listItems.get(i).setAdapter(this);
      	        }
      		}
      		

      		boolean isItemReady(int position) {
      			Boolean ready = readyItems.get(position);
      			return (ready != null && ready == true);
      		}
      		
      		void setItemReady(int position, boolean ready) {
      			readyItems.put(position, ready);
      		}
      		
      		/* Called once per item whenever the list needs to be refreshed */
      				@Override
      			    public View getView(int position, View convertView, ViewGroup parent) {
      			        View view = convertView;
      			        if (view == null) {
      			            LayoutInflater inflater =
      			                    (LayoutInflater) GameFriendsActivity.this
      			                    .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
      			            view = inflater.inflate(R.layout.list_item, null);
      			        }
      		
      			        FriendListItem item = listItems.get(position);
      			        item.setPosition(position);
      			        final int pos = position;
      			        if (item != null) {
      			        	if (item.getBitmap() == null && !isItemReady(position))
      			        	{
      			        		loadBitmap(item);
      			        	}
      			        	
      			            ImageView icon = (ImageView) view.findViewById(R.id.icon);
//      			          icon.setOnClickListener(new View.OnClickListener() {
//      			      	  public void onClick(View v) {
//      			      		  Log.w("DIALOG", "DIALOG");
//      				      	
///     				      }
  //    			      });

      			            TextView text = (TextView) view.findViewById(R.id.name);
      			          TextView info = (TextView) view.findViewById(R.id.onlinestatus);
      			            
      			            view.setOnClickListener(new View.OnClickListener() {
            			      	  public void onClick(View v) {
              			      		  
            			      		  showOptionsDialog(listItems.get(pos).getId(), listItems.get(pos).getName());
              			      		  //showGiftPopUp(listItems.get(pos).getId());
            			      		  //showMessageDialog(listItems.get(pos).getId(), listItems.get(pos).getName());
              				      	
              				      }
      			            });
      			            
      			            if (icon != null) {
      			            	icon.setImageBitmap(item.getBitmap());
      			            	
      				        	if (!isItemReady(position))
      				        	{
      				        		setItemReady(position, true);
      				        	}
      			            }
      			            if (text != null) {
      			                text.setText(item.getName());
      			            }
      			            if (info != null){
      			            	if(checkStatus(position)){
      			            		info.setText("Online");
      			            		info.setTextColor(Color.GREEN);
      			            	}
      			            	else{
      			            		info.setText("Offline");
      			            		info.setTextColor(Color.RED);
      			            	}
      			            }
      			        }
      			        return view;
      			    }
      
      	private Boolean checkStatus(int pos){
      		if(Integer.parseInt(onlinestatus.get(pos)) == 0){
      			return false;
      		} else if (Integer.parseInt(onlinestatus.get(pos)) == 1){
      			return true;
      		}
      		return false;
      	}
      				

		/** Loads the bitmap for the item or gets it from the cache. */
		private void loadBitmap(FriendListItem item) {
			
			
				ProfileImageLoader imageLoader = new ProfileImageLoader();
				ImageLoadData data = new ImageLoadData();
	        	data.setListItem(item);
	        	
	        	URL url;
				try {
					url = new URL("http", "graph.facebook.com", "/" + item.getId() + "/picture?type=small");
		        	data.setUrl(url);
		        	imageLoader.execute(data);
				} catch (MalformedURLException e) {
			
				}
			
		}
      				
      				
      				 private class ProfileImageLoader extends AsyncTask<ImageLoadData, Void, ImageLoadData> {
     		         	
     		         	/** Loads the bitmap from facebook */
     		 			@Override
     		 			protected ImageLoadData doInBackground(ImageLoadData... params) {
     		 			ImageLoadData data = params[0];
     		 				
     		 	        	URL url = data.getUrl();
     		 				try {
     		 		        	Bitmap bm = BitmapFactory.decodeStream(url.openConnection().getInputStream());
     		 		        	data.setBitmap(bm);
     		 				} catch (IOException e) {
     		 					Log.w(FriendsActivity.TAG, "Could not retrieve profile image!");
     		 				}
     		         	
     		 				return data;
     		 			}
     		 			
     		 			/** After loading, sets the bitmap to the corresponding item */
     		 			@Override
     		 			protected void onPostExecute(ImageLoadData result) {
     		 				if (result == null) return;
     		 				super.onPostExecute(result);
     		 				
     		 				Bitmap bitmap = result.getBitmap();
     		 				FriendListItem item = result.getListItem();
     		 				
     		 				item.setBitmap(bitmap);
     		 				
     		 			}
     		         	
     		         }        
     		 		}
          
		  
          

      	
      	void sendSandbagGift(String to) {
      	  	
      		toPerson = to;
      		
      	  	SendGiftTask task = new 	SendGiftTask();
      	  	task.execute();
      	  }
      	  
      	  private class SendGiftTask extends AsyncTask<Void, Void, Void> {

      			@Override
      			protected Void doInBackground(Void... params) {

				String url = "http://sondre.mannsverk.no/restful.php?from=" + playerID +"&to="+toPerson;
				HttpGet getRequest = new HttpGet(url);
				
				try {
					DefaultHttpClient httpClient = new DefaultHttpClient();
					HttpResponse getResponse = httpClient.execute(getRequest);
					
					final int statusCode = getResponse.getStatusLine().getStatusCode();
					
					if (statusCode != HttpStatus.SC_OK) { 
			            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
			        }

				} 
				catch (IOException e) {
					getRequest.abort();
			        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
				}
				return null;
      			}
      	  }
		  
	
          
          private class CancelListener implements OnCancelListener {

        	  	AsyncTask<?, ?, ?> cancellableTask;
        	  	
        	  	public CancelListener(AsyncTask<?, ?, ?> task) {
        	  		cancellableTask = task;
        			}
        	  	
        			@Override
        			public void onCancel(DialogInterface dialog) {
        				cancellableTask.cancel(true);
        			}
        	  	
        	  }
          
          
          // Show dialog for choosing an option
    	  private void showOptionsDialog(String toId, String name){
    		   		   final String id = toId;
    		   final String fullname = name;
    		      new AlertDialog.Builder(GameFriendsActivity.this)
    		          .setTitle("Option:")
    		          .setMessage(name)
    		          .setPositiveButton("Send message", new DialogInterface.OnClickListener() {
    		               public void onClick(DialogInterface dialog, int whichButton) {
    		                   showMessageDialog(id, fullname); 
    		               }
    		          })
    		          .setNeutralButton("Give gift", new DialogInterface.OnClickListener() {
    		               public void onClick(DialogInterface dialog, int whichButton) {
    		                      showGiftPopUp(id);
    		               }
    		          })
    		          .setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
    		               public void onClick(DialogInterface dialog, int whichButton) {
    		                      // Do nothing
    		               }
    		          }).show();
    	   } // end showMessageDialog
    	     
    	      
    	      
    	      
    	      // Show dialog for sending a message
    	  private void showMessageDialog(String toId, String name){
    		   final EditText input = new EditText(GameFriendsActivity.this);
    		   final String id = toId;
    		   final String fullname = name;
    		      new AlertDialog.Builder(GameFriendsActivity.this)
    		          .setTitle("Send message to:")
    		          .setMessage(name)
    		          .setView(input)
    		          .setPositiveButton("Send", new DialogInterface.OnClickListener() {
    		               public void onClick(DialogInterface dialog, int whichButton) {
    		                   editable = input.getText(); 
    		                   
    						httphandler.sendMessage(playerID, id, (editable.toString()));
    		                   toast("Message sent to " + fullname);
    		                   if(tutorial){
    		                	 showTutorialCompleteDialog();
    		                   }
    		               }
    		          })
    		          .setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
    		               public void onClick(DialogInterface dialog, int whichButton) {
    		                      // Do nothing.
    		               }
    		          }).show();
    	   } // end showMessageDialog
    	     
    	  	
     
    		//Show dialog for completed tutorial
    		public void showTutorialCompleteDialog(){
    		      new AlertDialog.Builder(GameFriendsActivity.this)
    		         .setTitle("The next step!")
      	          .setMessage("You have completed your training and are now ready for greater challenges. " +
      	          		"You receive 100 points and have gained the rank of Novice Volunteer! " +
      	          		"Complete quests to climb the leaderboards! ")
    		          .setPositiveButton("OK", new DialogInterface.OnClickListener() {
    			        	  public void onClick(DialogInterface dialog, int id) {
    			        		  Intent i = getIntent();
    		                	  i.putExtra("tutorial", true);
    		                	  setResult(RESULT_OK, i);
    		                	  httphandler.addPoints(playerID, Integer.toString(100));
    		                	  finish();
    						}}).show();
    		      
    	 } // end showTutorialComplete
    		

      	
    	  
    	  		// Show dialog for sending a gift
    			private void showGiftPopUp(String to) {

    				final String  to2 = to;
    				 AlertDialog.Builder helpBuilder = new AlertDialog.Builder(this);
    				 helpBuilder.setTitle("Send 5 sandbags?");
    				 helpBuilder.setMessage(R.string.sendgifts);
    				 helpBuilder.setPositiveButton("Give gift",
    				   new DialogInterface.OnClickListener() {

    				    public void onClick(DialogInterface dialog, int which) {
    				      sendSandbagGift(to2);
    				    }
    				   });
    				 helpBuilder.setNegativeButton("Close", new DialogInterface.OnClickListener() {

    					    public void onClick(DialogInterface dialog, int which) {
    					      
    					    }
    					   });

    				 // Remember, create doesn't show the dialog
    				 
    				  AlertDialog helpDialog = helpBuilder.create();
    				  helpDialog.show();
    			} // end showGiftPopUp
    	      
      		
}
	      
	      
	  

	

