package com.flooded;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.ArrayList;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import com.JSONParser.MessageHolder;
import com.JSONParser.MessageResponse;
import com.flooded.helperClasses.Helper;
import com.google.gson.Gson;

import android.annotation.SuppressLint;
import android.view.ViewGroup.LayoutParams;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.DialogInterface.OnCancelListener;
import android.graphics.Color;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.Toast;

public class InboxActivity extends Activity {
	
	 ArrayList<String> fromName;
	 ArrayList<String> text;
	 private String playerID;
	 TableLayout t1;
	 public ProgressDialog progressDialog;
	
		@Override
		protected void onCreate(Bundle savedInstanceState) {
			// TODO Auto-generated method stub
			super.onCreate(savedInstanceState);
			   setContentView(R.layout.inbox);
			   t1 = (TableLayout) findViewById(R.id.inbox);
			   Intent i = getIntent();
			   
			   playerID = "";
			   playerID = i.getStringExtra("playerID");
			   retrieveMessages();
			   
		}
		

		  void retrieveMessages() {
		  	
		  	progressDialog = ProgressDialog.show(this,
		      		"Please wait...", "Retrieving data...", true, true);

		  	MessageRetrieverAsyncTask task = new MessageRetrieverAsyncTask();
		  	task.execute();
		  	progressDialog.setOnCancelListener(new CancelListener(task));		
		  }
		  
		  private class MessageRetrieverAsyncTask extends AsyncTask<Void, Void, Void> {

		  	MessageResponse response;

				@Override
				protected Void doInBackground(Void... params) {
					String url = "http://sondre.mannsverk.no/getmessage.php?fbid="+playerID;
		  		HttpGet getRequest = new HttpGet(url);
		  		
		  		try {
		  			DefaultHttpClient httpClient = new DefaultHttpClient();
		  			HttpResponse getResponse = httpClient.execute(getRequest);
		  			
		  			final int statusCode = getResponse.getStatusLine().getStatusCode();
		  			
		  			if (statusCode != HttpStatus.SC_OK) { 
		  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
		  	            return null;
		  	        }

		  			HttpEntity getResponseEntity = getResponse.getEntity();
		  			InputStream httpResponseStream = getResponseEntity.getContent();
		  			Reader inputStreamReader = new InputStreamReader(httpResponseStream);
		  			
		              Gson gson = new Gson();
		              this.response = gson.fromJson(inputStreamReader, MessageResponse.class);
		  		} 
		  		catch (IOException e) {
		  			getRequest.abort();
		  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
		  		}

					return null;
				}
				
				@Override
				protected void onPostExecute(Void result) {
					super.onPostExecute(result);			

					text = new ArrayList<String>();
					fromName = new ArrayList<String>();
					
					try{
						for (MessageHolder message : this.response.data) {
							text.add(message.getText());
							fromName.add(message.getFromName());
						}
								
					buildInbox();
					}
					catch (NullPointerException e){
						Helper.displayText("No messages!", getBaseContext(), true);
						e.printStackTrace();
						
					}
					progressDialog.cancel();
					
		  	
		  }
		  }
		
		
				  private class CancelListener implements OnCancelListener {

					  	AsyncTask<?, ?, ?> cancellableTask;
					  	
					  	public CancelListener(AsyncTask<?, ?, ?> task) {
					  		cancellableTask = task;
							}
					  	
							@Override
							public void onCancel(DialogInterface dialog) {
								cancellableTask.cancel(true);
							}
					  	
					  }
		
		private void buildInbox(){
			TableRow tr_head = new TableRow(this);
			tr_head.setId(10);
			tr_head.setBackgroundColor(Color.GRAY);
			tr_head.setLayoutParams(new LayoutParams(
			LayoutParams.MATCH_PARENT,
			LayoutParams.WRAP_CONTENT));
			
			TextView messageHeader = new TextView(this);
	         messageHeader.setId(22);
	         messageHeader.setText("Message");
	         messageHeader.setTextColor(Color.WHITE);
	         messageHeader.setPadding(5, 5, 5, 5);
	         tr_head.addView(messageHeader);// add the column to the table row here
	         
	     	TextView fromHeader = new TextView(this);
	         fromHeader.setId(20);
	         fromHeader.setText("From");
	         fromHeader.setTextColor(Color.WHITE);
	         fromHeader.setPadding(5, 5, 5, 5);
	         tr_head.addView(fromHeader);// add the column to the table row here
			
	         t1.addView(tr_head, new TableLayout.LayoutParams(
	                 LayoutParams.MATCH_PARENT,
	                 LayoutParams.WRAP_CONTENT));
	         
	         Integer count=0;
	         
	         for(int i = 0; i < text.size(); i++){
	        String messageText = text.get(i);
	        String fromPlayer = fromName.get(i);
	        // Create the table row
	        TableRow tr = new TableRow(this);
	        tr.setBackgroundColor(Color.BLACK);
	        if(count%2!=0) tr.setBackgroundColor(Color.GRAY);
	        tr.setId(100+count);
	        tr.setLayoutParams(new LayoutParams(
	        		   LayoutParams.MATCH_PARENT,
		                 LayoutParams.WRAP_CONTENT));

	        //Create three columns to add as table data
	         // Create a TextView to add date
	        // Create a TextView to add date
	        
	        TextView labelDATE = new TextView(this);
	        labelDATE.setId(200+count); 
	        labelDATE.setText(messageText);
	        labelDATE.setPadding(2, 0, 5, 0);
	        labelDATE.setTextColor(Color.WHITE);
	        labelDATE.setMaxWidth(195);
	        tr.addView(labelDATE);
	        TextView labelPOS = new TextView(this);
	        labelPOS.setId(200+count); 
	        labelPOS.setText(fromPlayer);
	        labelPOS.setPadding(2, 0, 5, 0);
	        labelPOS.setTextColor(Color.WHITE);
	        tr.addView(labelPOS);
	        

	        // finally add this to the table row
	        t1.addView(tr, new TableLayout.LayoutParams(
	                   LayoutParams.MATCH_PARENT,
	                   LayoutParams.WRAP_CONTENT));
	              count++;
	        }
	         
		}
}
