package com.flooded;

import static PushNotification.CommonUtilities.DISPLAY_MESSAGE_ACTION;
import static PushNotification.CommonUtilities.EXTRA_MESSAGE;
import static PushNotification.CommonUtilities.SENDER_ID;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.ArrayList;
import java.util.Calendar;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import com.JSONParser.PlayerHolder;
import com.JSONParser.PlayerResponse;
import com.JSONParser.SessionHolder;
import com.JSONParser.SessionResponse;

import com.flooded.gameEntities.HUD;
import com.flooded.gameEntities.NPC;
import com.flooded.gameEntities.Session;
import com.flooded.gameEntities.Zone;
import com.flooded.helperClasses.HTTPHandler;
import com.flooded.helperClasses.Helper;
import com.flooded.quests.EvacuateQuest;
import com.flooded.quests.FloodProtectionQuest;
import com.flooded.quests.MonitorQuest;
import com.flooded.quests.Quest;
import com.flooded.quests.SearchQuest;
import com.flooded.quests.Tutorial;
import com.google.android.gcm.GCMRegistrar;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesNotAvailableException;
import com.google.android.gms.common.GooglePlayServicesUtil;
import com.google.android.gms.maps.CameraUpdate;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.GoogleMap.OnMyLocationChangeListener;
import com.google.android.gms.maps.MapsInitializer;

import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptor;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.CameraPosition;
import com.google.android.gms.maps.model.LatLng;

import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.maps.model.Polygon;

import com.google.gson.Gson;

import PushNotification.ConnectionDetector;
import PushNotification.WakeLocker;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.graphics.drawable.Drawable;
import android.location.Location;
import android.location.LocationManager;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.support.v4.app.FragmentActivity;
import android.text.Editable;
import android.util.AttributeSet;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class MapActivity extends FragmentActivity implements
		OnMyLocationChangeListener {

	// private static final LatLng TRONDHEIM = new LatLng(63.43,10.387922);

	private MyCount counter;
	private boolean allReady = false;

	// Connection detector
	ConnectionDetector cd;

	public TextView monitorNormalValue;

	public boolean googlePlayAvailable;
	private boolean initComplete, firstLocationCheck;
	private GoogleMap map;
	private BitmapDescriptor playerIcon;
	private Drawable satellite;
	private Drawable mapimage;
	private ArrayList<Marker> playerMarkers;
	private int points;
	public static final String PREFS_NAME = "MyData";
	private Location player;
	private Menu menu;
	Editable editable;
	public Session session;

	private long lastUpdate = 0;

	private int numberOfLocUpdates = 0;

	public long timeNow, sessionStartTime;

	TextView countdown;
	private String playerID;
	HTTPHandler httphandler;
	private Quest activeQ;

	static final int GET_MESSAGE_TUTORIAL = 1;

	ArrayList<Zone> zones;
	ArrayList<Polygon> polyZones;
	ArrayList<NPC> npcs;
	ArrayList<String> longi;
	ArrayList<String> lati;
	ArrayList<String> iscompleted;
	ArrayList<String> taggedby;
	ArrayList<String> type;
	ArrayList<String> pointlist;
	ArrayList<String> sandbaglist;
	ArrayList<String> npcfoundlist;
	ArrayList<String> notifiedlist;
	ArrayList<String> questid;

	ArrayList<String> playersFbid;
	ArrayList<String> otherPlayersLongi;
	ArrayList<String> otherPlayersLat;
	ArrayList<String> otherPlayersStatus;
	ArrayList<String> otherPlayersName;
	ArrayList<String> otherPlayersFbid;

	String provider;
	int timeoutCount;

	// Asynctask
	AsyncTask<Void, Void, Void> mRegisterTask;

	public boolean isInFront;

	public void setPoints(int points) {
		this.points = points;
	}

	public void initPushNotifications() {
		cd = new ConnectionDetector(getApplicationContext());

		// Check if Internet present
		if (!cd.isConnectingToInternet()) {
			// Internet Connection is not present

			// stop executing code by return
			return;
		}

		// Make sure the device has the proper dependencies.
		GCMRegistrar.checkDevice(this);

		// Make sure the manifest was properly set - comment out this line
		// while developing the app, then uncomment it when it's ready.
		GCMRegistrar.checkManifest(this);

		registerReceiver(mHandleQuestReceiver, new IntentFilter(
				DISPLAY_MESSAGE_ACTION));

		// Get GCM registration id
		final String regId = GCMRegistrar.getRegistrationId(this);

		// Check if regid already presents
		if (regId.equals("")) {
			// Registration is not present, register now with GCM
			GCMRegistrar.register(this, SENDER_ID);
		} else {
			// Device is already registered on GCM
			if (GCMRegistrar.isRegisteredOnServer(this)) {
				// Skips registration.
				// Toast.makeText(getApplicationContext(),
				// "Already registered with GCM", Toast.LENGTH_LONG).show();

			}
		}
	}

	@Override
	protected void onSaveInstanceState(Bundle bundle) {
		super.onSaveInstanceState(bundle);
	}

	@Override
	protected void onRestoreInstanceState(Bundle savedInstanceState) {
		super.onRestoreInstanceState(savedInstanceState);
	}

	@Override
	protected void onCreate(Bundle arg0) {
		super.onCreate(arg0);
		initPushNotifications();
		isInFront = true;

		try {
			MapsInitializer.initialize(this);
		} catch (GooglePlayServicesNotAvailableException e) {
			Log.e("GOOGLE PLAY FAILED", "debug");
			e.printStackTrace();
		}

		httphandler = new HTTPHandler();
		playerID = getIntent().getStringExtra("fbid");

		setContentView(R.layout.map);

		Intent i = getIntent();
		allReady = i.getBooleanExtra("allReady", false);

		if (!allReady) {
			SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
			allReady = settings.getBoolean("allReady", false);
		}

		initializeMap();
		SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
		boolean tutorialCompleted = settings.getBoolean("tutorialComp", false);

		if (tutorialCompleted) {
			getSession();
		} else {
			startTutorial();

		}
	}

	public void startEvaluation(Session session) {
//		Log.w(session.getId() + " " + session.getScore() + " "
//				+ session.getTimeStarted() + " " + session.isFinished(),
//				"debug");

		boolean isSessionOld = session.isSessionOld();
		{
			if (allReady) {
				if (isSessionOld) {
					session.setFinished(true);
					if (session.getId() == 0) {
						session.setId(-1);
					}
					httphandler.finishSession(session.getId());
					getSession();
				} else {
					switch (session.getCurrentQuest()) {
					case -1:
						startEvaluation(session);
						break;
					case 1:
						startFPQuest();
						break;
					case 2:
						startSNRQuest();
						break;
					case 4:
						boolean evacuate = getIntent().getBooleanExtra(
								"evacuate", false);
						Log.w(evacuate + " value", "debug");
						if (!evacuate) {
							startMonitorQuest();
						} else {
							startEvacQuest();
						}
						break;
					case 5:
						startEvacQuest();
						break;
					default:
						break;
					}
				}
			} else {
				activeQ = new Tutorial(map, MapActivity.this, playerID,
						getIntent(), null);
				getTutorialStatus();
			}
		}

	}

	@SuppressWarnings("unchecked")
	private void initializeData() {

		firstLocationCheck = false;
		initComplete = false;
		Intent inte = getIntent();

		playerMarkers = new ArrayList<Marker>();

		longi = new ArrayList<String>();
		longi = (ArrayList<String>) inte.getSerializableExtra("longitude");

		lati = new ArrayList<String>();
		lati = (ArrayList<String>) inte.getSerializableExtra("latitude");

		iscompleted = new ArrayList<String>();
		iscompleted = (ArrayList<String>) inte.getSerializableExtra("iscomp");

		type = new ArrayList<String>();
		type = (ArrayList<String>) inte.getSerializableExtra("type");

		taggedby = new ArrayList<String>();
		taggedby = (ArrayList<String>) inte.getSerializableExtra("taggedby");

		playersFbid = new ArrayList<String>();
		playersFbid = (ArrayList<String>) inte.getSerializableExtra("fbids");

		pointlist = new ArrayList<String>();
		pointlist = (ArrayList<String>) inte.getSerializableExtra("points");

		sandbaglist = new ArrayList<String>();
		sandbaglist = (ArrayList<String>) inte.getSerializableExtra("sandbags");

		npcfoundlist = new ArrayList<String>();
		npcfoundlist = (ArrayList<String>) inte
				.getSerializableExtra("npcfound");

		notifiedlist = new ArrayList<String>();
		notifiedlist = (ArrayList<String>) inte
				.getSerializableExtra("notified");

		questid = new ArrayList<String>();
		questid = (ArrayList<String>) inte.getSerializableExtra("questid");

		int pts = getIntent().getIntExtra("updatedPoints",
				Integer.parseInt(pointlist.get(0)));

		setPoints(pts);

	}

	// Initializes map according to which quest is active

	private void initializeMap() {
		initializeData(); // initialize quest and player data
		setUpMapIfNeeded(); // display map
		getPlayerPos(); // set markers of other players
	} // end initializeMap()

	private void startTutorial() {
		activeQ = new Tutorial(map, MapActivity.this, playerID, getIntent(),
				null);
		activeQ.setPoints(points);
		SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
		activeQ.setPhase(settings.getInt("tutorialPhase", 0));

		activeQ.initQuest();
		activeQ.initQuestSpecific();

		initComplete = true;
		if (activeQ.getPhase() == 3) {

			SharedPreferences.Editor editor = settings.edit();
			editor.putBoolean("tutorialComp", true);
			editor.commit();

			activeQ = new Tutorial(map, MapActivity.this, playerID,
					getIntent(), null);
			getTutorialStatus();
		}
	}

	private void startFPQuest() {
		activeQ = new FloodProtectionQuest(map, MapActivity.this, playerID,
				session);
		activeQ.initQuestSpecific(sandbaglist, lati, longi, questid, type,
				iscompleted);
		activeQ.setPoints(points);
		startCountdown(session.getQuestTimeRemaining());
		activeQ.initQuest();
	}

	private void startSNRQuest() {
		activeQ = new SearchQuest(map, MapActivity.this, playerID, session);
		activeQ.setPoints(points);
		startCountdown(session.getQuestTimeRemaining());
		activeQ.initQuest(notifiedlist, npcfoundlist);
		activeQ.initQuestSpecific();
		initComplete = true;
	}

	private void startMonitorQuest() {
		activeQ = new MonitorQuest(map, MapActivity.this, playerID, session);
		activeQ.setPoints(points);
		activeQ.initQuestSpecific(questid, lati, longi, iscompleted, type);
		startCountdown(session.getQuestTimeRemaining());
		activeQ.initQuest();
	}

	private void startEvacQuest() {
		activeQ = new EvacuateQuest(map, MapActivity.this, playerID, session);
		activeQ.setPoints(points);
		startCountdown((session.getQuestTimeRemaining()));
		Log.w("Time: " + session.getQuestTimeRemaining() + " - "
				+ session.getExtraEvacTime(), "debug");
		activeQ.initQuest();
	}

	@Override
	protected void onActivityResult(int arg0, int arg1, Intent arg2) {
		super.onActivityResult(arg0, arg1, arg2);

		if (activeQ.getId() == Quest.tutorialQuest) {
			if (arg0 == GET_MESSAGE_TUTORIAL) {
				if (arg1 == RESULT_OK) {
					boolean tutC = arg2.getBooleanExtra("tutorial", false);

					if (tutC) {
						activeQ.setPhase(Tutorial.messageSent);
						httphandler.tutorialFinished(this);

						SharedPreferences settings = getSharedPreferences(
								PREFS_NAME, 0);
						SharedPreferences.Editor editor = settings.edit();
						editor.putBoolean("tutorialComp", true);
						editor.commit();

						activeQ = new Tutorial(map, MapActivity.this, playerID,
								getIntent(), null);
						getTutorialStatus();

					} else {
						activeQ.setPhase(Tutorial.sandbagPlaced);
					}
				}
			}
		}
	}

	private void startGame() {
		if (allReady) {
			Intent intent = getIntent();
			intent.putExtra("allReady", true);

			SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
			SharedPreferences.Editor editor = settings.edit();
			editor.putBoolean("allReady", true);
			editor.commit();

			finish();
			startActivity(intent);
		}
	}

	private void startCountdown(long duration) {

		counter = new MyCount(duration, 1000);
		counter.start();

	}

	// Initialize icons
	private void initializeIcons() {

		playerIcon = BitmapDescriptorFactory
				.fromResource(R.drawable.friend_new);

		satellite = this.getResources().getDrawable(R.drawable.satellite);
		satellite.setBounds(0 - satellite.getIntrinsicWidth() / 2,
				0 - satellite.getIntrinsicHeight(),
				satellite.getIntrinsicWidth() / 2, 0);

		mapimage = this.getResources().getDrawable(R.drawable.map);
		mapimage.setBounds(0 - mapimage.getIntrinsicWidth() / 2,
				0 - mapimage.getIntrinsicHeight(),
				mapimage.getIntrinsicWidth() / 2, 0);

	} // end initIcons()

	private void setUpMapIfNeeded() {
		// Getting Google Play availability status
		int status = GooglePlayServicesUtil
				.isGooglePlayServicesAvailable(getBaseContext());

		// Showing status
		if (status != ConnectionResult.SUCCESS) { // Google Play Services are
													// not available
			int requestCode = 10;
			Dialog dialog = GooglePlayServicesUtil.getErrorDialog(status, this,
					requestCode);
			dialog.show();

		} else { // Google Play Services are available

			// Getting reference to the SupportMapFragment of activity_main.xml
			SupportMapFragment fm = (SupportMapFragment) getSupportFragmentManager()
					.findFragmentById(R.id.map);

			// Getting GoogleMap object from the fragment
			if (map == null) {
				map = fm.getMap();
			}

			// Enabling MyLocation Layer of Google Map
			map.setMyLocationEnabled(true);

			// Setting event handler for location change
			map.setOnMyLocationChangeListener(this);

			map.getUiSettings().setRotateGesturesEnabled(false);

			initializeIcons(); // initialize icons
		}
	}

	@Override
	public void onMyLocationChange(Location location) {

		// // Getting latitude of the current location
		double latitude = location.getLatitude();

		// Getting longitude of the current location
		double longitude = location.getLongitude();

		// Creating a LatLng object for the current location
		LatLng latLng = new LatLng(latitude, longitude);

		CameraUpdate myLocZoom = CameraUpdateFactory
				.newCameraPosition(new CameraPosition.Builder().target(latLng)
						.zoom(17).build());

		float newzoom = map.getCameraPosition().zoom;
		if (newzoom > 18 || newzoom < 16) {
			newzoom = 17;
		}

		if (!firstLocationCheck) {
			map.animateCamera(myLocZoom);
			firstLocationCheck = true;
		}

		numberOfLocUpdates = numberOfLocUpdates + 1;

		// Move camera to more accurate positions

		if (numberOfLocUpdates == 2) {
			map.animateCamera(myLocZoom);
			Log.w("Number of updates: " + numberOfLocUpdates, "debug");
		}

		boolean updated = false;

		if (player != null) {
			if (location.distanceTo(player) > 10F) {
				if (isInFront) {
					player = new Location(location);
					httphandler.updatePlayerPosition(this, true, player,
							playerID);
					Log.w("test of location update", "debug");
				}
			}
		} else {
			if (isInFront) {
				player = new Location(location);
				if (!updated) {
					httphandler.updatePlayerPosition(this, true, player,
							playerID);
					updated = true;
				}

				Log.w("test of location update 2", "debug");
			}
		}

		if (initComplete) {
			// Do necessary quest actions
			if (activeQ.getId() == Quest.snrQuest) {
				if (player != null) {
					if (location.distanceTo(player) > 5F) {
						Log.w("Checking if in flood", "flood");
						Log.w("Location: " + location.getLatitude() + ","
								+ location.getLongitude(), "flood");
						Log.w("Player: " + player.getLatitude() + ","
								+ player.getLongitude(), "flood");
						Log.w("Distance: " + location.distanceTo(player),
								"flood");
						activeQ.initQuestSpecific();
					}
				}
			}
		}

	}

	/**
	 * Event Handling for Individual menu item selected Identify single menu
	 * item by it's id
	 * */

	public void displayText(String text) {
		if (isInFront) {
			Toast.makeText(MapActivity.this, text, Toast.LENGTH_LONG).show();
		}
	}

	public class MyCount extends CountDownTimer {

		public MyCount(long millisInFuture, long countDownInterval) {
			super(millisInFuture, countDownInterval);
		}

		@Override
		public void onFinish() {
			activeQ.getHud().setTimerText("00 : 00");
			activeQ.finishQuest();
		}

		@Override
		public void onTick(long millisUntilFinished) {
			// countdown.setText("Time left: " +
			// formatTime(millisUntilFinished));
			activeQ.setTimeRemaining(millisUntilFinished);
			if (millisUntilFinished < 61000) {
				activeQ.getHud().changeTimerColor();
			}
			activeQ.getHud().setTimerText(formatTime(millisUntilFinished));

			if (lastUpdate == 0 || (lastUpdate - millisUntilFinished) > 10000) {
				lastUpdate = millisUntilFinished;
			}

			if (activeQ.getId() == Quest.snrQuest) {
				if (!activeQ.isPlayerAlive()) {
					if (activeQ.getTimeUntilAlive() <= 0) {
						if (!((SearchQuest) activeQ).flood
								.playerInsideFlood(map.getMyLocation())) {
							Log.w("revived from activity", "flood");
							activeQ.revivePlayer();
							activeQ.displayReviveMessage();
							if (!activeQ.isFinished()) {
								activeQ.initQuestSpecific();
							}
						} else {
							Log.w("killed from activity", "flood");
							if (!activeQ.isPlayerAlive()) {
								activeQ.killPlayer();
							}
						}
					}
				}
			}
		}
	}

	public String formatTime(long millis) {
		String output = "00:00";
		long seconds = millis / 1000;
		long minutes = seconds / 60;

		seconds = seconds % 60;
		minutes = minutes % 60;

		String sec = String.valueOf(seconds);
		String min = String.valueOf(minutes);

		if (seconds < 10)
			sec = "0" + seconds;
		if (minutes < 10)
			min = "0" + minutes;

		output = min + " : " + sec;
		return output;
	}// formatTime

	// Fetches position of other players from the database
	void getPlayerPos() {

		PlayerRetrieverAsyncTask task = new PlayerRetrieverAsyncTask();
		task.execute();

	}

	private class PlayerRetrieverAsyncTask extends AsyncTask<Void, Void, Void> {

		PlayerResponse response;

		@Override
		protected Void doInBackground(Void... params) {

			String url = "http://sondre.mannsverk.no/restful.php";
			HttpGet getRequest = new HttpGet(url);

			try {
				DefaultHttpClient httpClient = new DefaultHttpClient();
				HttpResponse getResponse = httpClient.execute(getRequest);

				final int statusCode = getResponse.getStatusLine()
						.getStatusCode();

				if (statusCode != HttpStatus.SC_OK) {
					Log.w(getClass().getSimpleName(), "Error " + statusCode
							+ " for URL " + url);

					return null;
				}

				HttpEntity getResponseEntity = getResponse.getEntity();
				InputStream httpResponseStream = getResponseEntity.getContent();
				Reader inputStreamReader = new InputStreamReader(
						httpResponseStream);

				Gson gson = new Gson();
				this.response = gson.fromJson(inputStreamReader,
						PlayerResponse.class);
			} catch (IOException e) {
				getRequest.abort();
				Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
			}

			return null;
		}

		@Override
		protected void onPostExecute(Void result) {
			super.onPostExecute(result);

			otherPlayersLat = new ArrayList<String>();
			otherPlayersLongi = new ArrayList<String>();
			otherPlayersStatus = new ArrayList<String>();
			otherPlayersName = new ArrayList<String>();
			otherPlayersFbid = new ArrayList<String>();

			try {
				for (PlayerHolder player : this.response.data) {

					if (!player.getFbid().equals(playerID)) {
						otherPlayersLat.add(player.getLat());
						otherPlayersLongi.add(player.getLongi());
						otherPlayersStatus.add(player.getOnline());
						otherPlayersName.add(player.getName());
						otherPlayersFbid.add(player.getFbid());
					}
				}

				for (int i = 0; i < otherPlayersLat.size(); i++) {

					if (!otherPlayersFbid.get(i).equals(playerID)) {
						Marker pM = map.addMarker(new MarkerOptions()
								.position(
										new LatLng(Double
												.parseDouble(otherPlayersLat
														.get(i)), Double
												.parseDouble(otherPlayersLongi
														.get(i))))
								.icon(playerIcon)
								.title(otherPlayersName.get(i)));
						if ((Integer.parseInt(otherPlayersStatus.get(i))) != 1) {
							pM.setVisible(false);
						}
						playerMarkers.add(pM);
						Log.w(otherPlayersFbid.get(i) + " playerid - "
								+ playerID + "player status: "
								+ Integer.parseInt(otherPlayersStatus.get(i)),
								"debug");

					}
				}
			} catch (NullPointerException e) {
				e.printStackTrace();
				Log.w("Failed fetching player locations! No internet connection?",
						"debug");
			}

		}
	} // end getPlayerPos()

	// Fetches current session
	void getSession() {

		Calendar calNow = Calendar.getInstance();
		long time = calNow.getTimeInMillis();
		timeoutCount++;
		timeNow = time;

		if (timeoutCount > 50) {
			Helper.displayText("You lost internet connection!", this, true);
			finish();
			return;
		}

		SessionRetrieverAsyncTask task = new SessionRetrieverAsyncTask();
		task.execute();

	}

	private class SessionRetrieverAsyncTask extends AsyncTask<Void, Void, Void> {

		SessionResponse response;

		@Override
		protected Void doInBackground(Void... params) {

			String url = "http://sondre.mannsverk.no/session.php?time="
					+ Long.toString(timeNow) + "&fbid=" + playerID;
			HttpGet getRequest = new HttpGet(url);

			try {
				DefaultHttpClient httpClient = new DefaultHttpClient();
				HttpResponse getResponse = httpClient.execute(getRequest);

				final int statusCode = getResponse.getStatusLine()
						.getStatusCode();

				if (statusCode != HttpStatus.SC_OK) {
					Log.w(getClass().getSimpleName(), "Error " + statusCode
							+ " for URL " + url);

					return null;
				}

				HttpEntity getResponseEntity = getResponse.getEntity();
				InputStream httpResponseStream = getResponseEntity.getContent();
				Reader inputStreamReader = new InputStreamReader(
						httpResponseStream);

				Gson gson = new Gson();
				this.response = gson.fromJson(inputStreamReader,
						SessionResponse.class);
			} catch (IOException e) {
				getRequest.abort();

			}

			return null;
		}

		@Override
		protected void onPostExecute(Void result) {
			super.onPostExecute(result);

			String sessionId = "";
			String score = "";
			String finished = "";
			String timeStarted = "";
			String extraEvacTime = "";
			String numOfDeaths = "";
			String FBID = "";

			try {

				for (SessionHolder session : this.response.data) {
					sessionId = session.getId();
					score = session.getFloodProtectionScore();
					finished = session.getFinished();
					timeStarted = session.getTimeStarted();
					extraEvacTime = session.getExtraEvacTime();
					numOfDeaths = session.getNumOfDeaths();
					FBID = session.getFbid();
				}
				session = new Session(Long.parseLong(timeStarted));
				session.setId(Integer.parseInt(sessionId));
				session.setScore(Integer.parseInt(score));
				session.setCurrentTime(timeNow);
				session.setExtraEvacTime(Long.parseLong(extraEvacTime));
				session.setNumOfDeaths(Integer.parseInt(numOfDeaths));
				session.setFbid(Long.parseLong(FBID));

				if (finished.equals("0")) {
					session.setFinished(false);
				} else {
					session.setFinished(true);
				}
				Log.w("Old session!", "debug");

			} catch (Exception e) {
				Log.w("New session!", "debug");
				session = new Session(timeNow);
				session.setScore(0);
				session.setFinished(false);
				session.setCurrentTime(timeNow);
				session.setId(0);
				session.setExtraEvacTime(0);
				session.setNumOfDeaths(0);
				session.setFbid(Long.parseLong(playerID));
				e.printStackTrace();
			}

			if (session.getId() == 0) {
				getSession();
			} else {
				startEvaluation(session);
			}

		}
	} // end getSession()

	// Fetches status of tutorial
	void getTutorialStatus() {

		TutorialStatusAsyncTask task = new TutorialStatusAsyncTask();
		task.execute();

	}

	private class TutorialStatusAsyncTask extends AsyncTask<Void, Void, Void> {

		SessionResponse response;

		@Override
		protected Void doInBackground(Void... params) {

			String url = "http://sondre.mannsverk.no/session.php?tutorialStatus";
			HttpGet getRequest = new HttpGet(url);

			try {
				DefaultHttpClient httpClient = new DefaultHttpClient();
				Log.w("Test", "Test");
				HttpResponse getResponse = httpClient.execute(getRequest);

				final int statusCode = getResponse.getStatusLine()
						.getStatusCode();

				if (statusCode != HttpStatus.SC_OK) {
					Log.w(getClass().getSimpleName(), "Error " + statusCode
							+ " for URL " + url);

					return null;
				}

				HttpEntity getResponseEntity = getResponse.getEntity();
				InputStream httpResponseStream = getResponseEntity.getContent();
				Reader inputStreamReader = new InputStreamReader(
						httpResponseStream);

				Gson gson = new Gson();
				this.response = gson.fromJson(inputStreamReader,
						SessionResponse.class);
			} catch (IOException e) {
				getRequest.abort();

			}

			return null;
		}

		@Override
		protected void onPostExecute(Void result) {
			super.onPostExecute(result);

			String ready = "";

			try {

				for (SessionHolder session : this.response.data) {
					ready = session.getReady();

				}

				if (Integer.parseInt(ready) >= 5) {
					allReady = true;
					if (session != null) {
						startEvaluation(session);
					}
				} else {
					if (isInFront) {
						Toast.makeText(
								MapActivity.this,
								"Not everyone has completed the tutorial yet. Please wait!",
								Toast.LENGTH_LONG).show();
					}
				}

			} catch (Exception e) {

			}

		}
	}

	@Override
	protected void onStop() {
		super.onStop();
		isInFront = false;

		try {

			if (activeQ.getId() == Quest.tutorialQuest) {
				SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
				SharedPreferences.Editor editor = settings.edit();
				editor.putInt("tutorialPhase", activeQ.getPhase());
				// Commit the edits!
				editor.commit();

				httphandler.updatePlayerStatus(MapActivity.this, playerID);

			}
		} catch (NullPointerException e) {
			Log.w("onStop() failed", "debug");
			e.printStackTrace();
		}

	}

	@Override
	protected void onDestroy() {

		// Unlisten to push notifications
		if (mRegisterTask != null) {
			mRegisterTask.cancel(true);
		}
		try {
			unregisterReceiver(mHandleQuestReceiver);
			GCMRegistrar.onDestroy(this);
		} catch (Exception e) {
			Log.e("UnRegister Receiver Error", "> " + e.getMessage());
		}

		super.onDestroy();
	}

	@Override
	protected void onPause() {

		try {
			if (activeQ.getId() == Quest.tutorialQuest) {
				SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
				SharedPreferences.Editor editor = settings.edit();
				editor.putInt("tutorialPhase", activeQ.getPhase());
				// Commit the edits!
				editor.commit();
			}
		} catch (NullPointerException e) {
			Log.w("onPause() failed", "debug");
			e.printStackTrace();
		}
		isInFront = false;
		super.onPause();

	}

	@Override
	protected void onResume() {
		super.onResume();
		setUpMapIfNeeded();
		isInFront = true;
	}

	public Boolean getBoolFromString(String s) {

		if (Integer.parseInt(s) == 1) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * Receiving push messages
	 * */
	private final BroadcastReceiver mHandleQuestReceiver = new BroadcastReceiver() {

		@Override
		public void onReceive(Context context, Intent intent) {

			String newMessage = intent.getExtras().getString(EXTRA_MESSAGE);
			// Waking up mobile if it is sleeping
			WakeLocker.acquire(getApplicationContext());

			/**
			 * Take appropriate action on this message depending upon your app
			 * requirement For now i am just displaying it on the screen
			 * */
			if (newMessage != null) {
				String[] analyzedMessage = newMessage.split(" ");
				
				if (analyzedMessage.length != 0) {
					if (analyzedMessage[0].equalsIgnoreCase("newsandbag")) {
						addSandbag(analyzedMessage);
					} else if (analyzedMessage[0]
							.equalsIgnoreCase("updatequest")) {
						updateQuest(analyzedMessage);
					} else if (analyzedMessage[0]
							.equalsIgnoreCase("evacuatenow")) {
						startEvacuation(analyzedMessage);
					} else if (analyzedMessage[0]
							.equalsIgnoreCase("tutorialstarted")) {
						allReady();
					} else if (analyzedMessage[0]
							.equalsIgnoreCase("extrapoints")) {
						giveExtraPoints(analyzedMessage);
					} else if (analyzedMessage[0]
							.equalsIgnoreCase("zonesearched")) {
						updateZone(analyzedMessage);
					} else if (analyzedMessage[0]
							.equalsIgnoreCase("zonenotified")) {
						updateZone(analyzedMessage);
					} else if (analyzedMessage[0]
							.equalsIgnoreCase("playeroffline")) {
						removePlayerDot(analyzedMessage);
					} else if (analyzedMessage[0]
							.equalsIgnoreCase("playermoved")) {
						movePlayerDot(analyzedMessage);
					} else {
						Toast.makeText(getApplicationContext(),
								"New message: " + newMessage, Toast.LENGTH_LONG)
								.show();
					}
				}

			}

			// Releasing wake lock
			WakeLocker.release();
		}
	};

	private void removePlayerDot(String[] analyzedMessage) {
		if (analyzedMessage.length == 2 && playerMarkers.size() > 0
				&& otherPlayersFbid.size() > 0) {
			String id = analyzedMessage[1];
			if (id != playerID) {
				for (int i = 0; i < otherPlayersFbid.size(); i++) {
					if (otherPlayersFbid.get(i).equals(id)
							&& i < playerMarkers.size()) {
						playerMarkers.get(i).setVisible(false);
					}
				}
			}
		}
	}

	private void movePlayerDot(String[] analyzedMessage) {
		if (analyzedMessage.length == 4 && playerMarkers.size() > 0
				&& otherPlayersFbid.size() > 0) {
			String id = analyzedMessage[1];
			String lat = analyzedMessage[2];
			String lng = analyzedMessage[3];

			Double latVal = Double.parseDouble(lat);
			Double lngVal = Double.parseDouble(lng);

			if (id != playerID) {
				for (int i = 0; i < otherPlayersFbid.size(); i++) {
					if (otherPlayersFbid.get(i).equals(id)
							&& i < playerMarkers.size()) {
						playerMarkers.get(i).setPosition(
								new LatLng(latVal, lngVal));
						if (!playerMarkers.get(i).isVisible()) {
							playerMarkers.get(i).setVisible(true);
						}
					}
				}
			}
		}
	}

	private void giveExtraPoints(String[] analyzedMessage) {
		if (analyzedMessage.length == 2) {
			if (activeQ != null) {
				double points = Double.parseDouble(analyzedMessage[1]);
				activeQ.rewardPlayer((int) points);
				if (isInFront) {
					Toast.makeText(
							getApplicationContext(),
							"You gained another " + (int) points
									+ " points for your group's effort!",
							Toast.LENGTH_LONG).show();
				}
			}
		}
	}

	private void allReady() {
		if (activeQ != null) {
			if (activeQ.getId() == Quest.tutorialQuest) {
				allReady = true;
				startGame();
			}
		} else {

		}
	}

	private void addSandbag(String[] message) {
		if (message.length == 5) {
			double lat = Double.parseDouble(message[1]);
			double lng = Double.parseDouble(message[2]);
			int questtype = Integer.parseInt(message[3]);
			int distance = Integer.parseInt(message[4]);
			addSandbagUpdate(lat, lng, questtype, distance);
		}
	}

	private void updateQuest(String[] message) {
		if (message.length == 2) {
			if (activeQ.getId() == Quest.floodProtectionQuest) {
				int questId = Integer.parseInt(message[1]);
				removeCrateUpdate(questId);
			} else if (activeQ.getId() == Quest.monitorQuest) {
				int questId = Integer.parseInt(message[1]);
				((MonitorQuest) activeQ).updateWaterQuest(questId);
			}
		}
	}

	boolean evacuated = false;
	
	private void startEvacuation(String[] message) {
		if(!evacuated){
			if (message.length == 2) {
				if (activeQ != null) {
					if (activeQ.getId() == Quest.monitorQuest) {
						evacuated = true;
						activeQ.restartActivity(true);
					}
				}
			}
		}
	}

	private void updateZone(String[] message) {
		int questId = Integer.parseInt(message[1]);
		if (message.length == 3) {
			int notified = Integer.parseInt(message[2]);
			updateNotified(questId, notified);
		} else if (message.length == 2) {
			updateFound(questId);
		}

	}

	private void updateNotified(int questId, int notified) {
		if (activeQ != null) {
			if (activeQ.getId() == Quest.snrQuest) {
				((SearchQuest) activeQ).updateZone(questId, notified);
			}
		}
	}

	private void updateFound(int questId) {
		if (activeQ != null) {
			if (activeQ.getId() == Quest.snrQuest) {
				((SearchQuest) activeQ).updateZone(questId, 0);
			}
		}
	}

	private void addSandbagUpdate(double lat, double lng, int questtype,
			int distance) {
		if (activeQ != null) {
			if (activeQ.getId() == Quest.floodProtectionQuest) {
				((FloodProtectionQuest) activeQ).addSandbag(lat, lng,
						questtype, distance);
			}
		}
	}

	private void removeCrateUpdate(int questId) {
		if (activeQ != null) {
			if (activeQ.getId() == Quest.floodProtectionQuest) {
				((FloodProtectionQuest) activeQ).removeCrate(questId);
			}
		}
	}

}
