package com.flooded;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import com.facebook.model.GraphUser;
import com.facebook.Request;
import com.facebook.Response;
import com.facebook.Session;
import com.facebook.UiLifecycleHelper;
import com.flooded.gameEntities.Rank;
import com.flooded.helperClasses.HTTPHandler;
import com.flooded.helperClasses.Helper;



import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.TextView;

public class ProfileActivity extends Activity {

	String fbid;
	String names;
	String name;
	String points;
	String sandbags;
	private UiLifecycleHelper uiHelper;
	  HTTPHandler httphandler;

	  @Override
	  public void onActivityResult(int requestCode, int resultCode, Intent data) {
	      super.onActivityResult(requestCode, resultCode, data);
	      Session.getActiveSession().onActivityResult(this, requestCode, resultCode, data);
	  }
	  
	
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
	      setContentView(R.layout.player);
	      uiHelper = new UiLifecycleHelper(this,  null);
		  uiHelper.onCreate(savedInstanceState);
	      Session.openActiveSession(this, true, null);
	      httphandler = new HTTPHandler();
	      Intent i = getIntent();
		   name = "";
		   name = i.getExtras().getString("name");
	   
		   points = "";
		   points = i.getExtras().getString("points");
		   
		   sandbags = "";
		   sandbags = i.getExtras().getString("sandbags");
		   
		   fbid = "";
		   fbid = i.getExtras().getString("fbid");
	      
		  TextView nameView = (TextView) findViewById(R.id.name);
          nameView.setText(name);
		   
          TextView point = (TextView) findViewById(R.id.points);
          point.setText("Points: " + points);
          
          Rank rank = new Rank(Integer.parseInt(points));
          
          TextView rankTV = (TextView) findViewById(R.id.rank);
          rankTV.setText("Rank: " + rank.getCurrentTitle());
          
          ProgressBar mProgress = (ProgressBar) findViewById(R.id.progress);
          mProgress.setMax(rank.pointsForNext());
          mProgress.setProgress(Integer.parseInt(points));
          
	      
          TextView sandbag = (TextView) findViewById(R.id.sandbags);
          sandbag.setText("Sandbags: " + sandbags);
          
          ImageView user_picture;
	      user_picture=(ImageView)findViewById(R.id.profile_pic);
	      downloadAvatar(fbid, user_picture);

	      
	}
	
	private synchronized void downloadAvatar(final String user_id,final ImageView iv) {
        AsyncTask<Void, Void, Bitmap> task = new AsyncTask<Void, Void, Bitmap>() {

            @Override
            public Bitmap doInBackground(Void... params) {
                URL fbAvatarUrl = null;
                Bitmap fbAvatarBitmap = null;
                try {
                    fbAvatarUrl = new URL("http://graph.facebook.com/"+user_id+"/picture?type=large");
                    fbAvatarBitmap = BitmapFactory.decodeStream(fbAvatarUrl.openConnection().getInputStream());
                } catch (MalformedURLException e) {
                    e.printStackTrace();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                return fbAvatarBitmap;
            }

            @Override
            protected void onPostExecute(Bitmap result) {


                iv.setImageBitmap(result);
            }

        };
        task.execute();
    }
	
	
    
		@Override
		public boolean onCreateOptionsMenu(Menu menu) {
			    MenuInflater inflater = getMenuInflater();
			    inflater.inflate(R.menu.profile_menu, menu);
		    return true;
		}
		
		@Override
		public boolean onOptionsItemSelected(MenuItem item) {
		    switch (item.getItemId()) {
		        case R.id.menutext7:
		        	displayChangeUsernameDialog(this, fbid, httphandler);
		        	break;
		      
		    }
		    return true;
		}
	
	
	
	
	private void displayChangeUsernameDialog(final Context context, final String playerID, final HTTPHandler httphandler) {

			    
			AlertDialog.Builder builder = new AlertDialog.Builder(context);
			    // Get the layout inflater
			    LayoutInflater inflater = ((Activity)context).getLayoutInflater();
			    View view = inflater.inflate(R.layout.username, null);
			    // Inflate and set the layout for the dialog
			    // Pass null as the parent view because its going in the dialog layout
			    builder.setView(view);
			    final EditText userName = (EditText)view.findViewById(R.id.userName);

			    
			    builder.setTitle("Change username:");
			    
			    // Add action buttons
			           builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
			               @Override
			               public void onClick(DialogInterface dialog, int id) {
			            	   
			            	   String username = userName.getText().toString();
			            	   if(!userName.getText().toString().equals("")){
			            			  TextView nameView = (TextView) findViewById(R.id.name);
			            	          nameView.setText(username);
			            		   httphandler.changeUsername(context, playerID, username);
			            		   
			            	   }
			            	   
			            	   if(username.equals("") || username.equals(" ") ){
			            		   Log.w("Username is: " + username, "debug");
			            		   Helper.displayText("Username was empty.", context, true);
			                 	   displayChangeUsernameDialog(context, playerID, httphandler);
			            		   
			            	   } else if(username.length() > 20){
			            		   Helper.displayText("Username was too long. Maximum is 20 characters.", context, true);
			            		   displayChangeUsernameDialog(context, playerID, httphandler);
			            	   }
			            
			               }
			           });
			           
			           builder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
			               @Override
			               public void onClick(DialogInterface dialog, int id) {
			               }});

				AlertDialog dialog = builder.create();
				dialog.setView(view, 0, 0, 0, 0);
				dialog.show();
			    
		  
			
		}



	private void displayImage(){
		 Request request = Request.newMeRequest(Session.getActiveSession(), new Request.GraphUserCallback() {
		        // callback after Graph API response with user object
		        @Override
		        public void onCompleted(GraphUser user, Response response) {
		          if (user != null) {
		            
		            //fbid = user.getId();
		            Log.w(fbid + "", "Debug");
		             ImageView user_picture;
				      user_picture=(ImageView)findViewById(R.id.profile_pic);
				      URL img_value = null;

				      try {
						img_value = new URL("http://graph.facebook.com/"+fbid+"/picture?type=large");
					} catch (MalformedURLException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				      Bitmap mIcon1;
					try {
						mIcon1 = BitmapFactory.decodeStream(img_value.openConnection().getInputStream());
						 user_picture.setImageBitmap(mIcon1);
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
		          }
		        }
		      });
		      Request.executeBatchAsync(request);
//		displayImageAsyncTask task = new displayImageAsyncTask();
//	 	task.execute();
	 			
	 }
	
	private class displayImageAsyncTask extends AsyncTask<Void, Void, Void> {

		@Override
		protected Void doInBackground(Void... params) {
		
			return null;
		}}


	
}
