package com.flooded.gameEntities;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.text.Editable;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ProgressBar;
import android.widget.TextView;

import com.flooded.GameFriendsActivity;
import com.flooded.InboxActivity;
import com.flooded.R;
import com.flooded.helperClasses.Helper;
import com.flooded.quests.Quest;
import com.flooded.quests.Tutorial;

public class HUD {

	static final int GET_MESSAGE_TUTORIAL = 1; 
	Editable editable;
	private TextView timerText;
	private	TextView sandbagText;
	private	TextView sandbagImage;
	private TextView pointsText;
	private	TextView pointsImage;
	private Button interactButton;
	private ProgressBar deathBar;
	
	Context context;
	Quest activeQ;
	
	public HUD(Context context, Quest quest) {
		 timerText = (TextView) ((Activity)context).findViewById (R.id.timer);
		 sandbagText = (TextView) ((Activity)context).findViewById (R.id.sandbagCount);
		 pointsText = (TextView) ((Activity)context).findViewById (R.id.pointsCount);
		 sandbagImage = (TextView) ((Activity)context).findViewById (R.id.sand);
		 pointsImage = (TextView) ((Activity)context).findViewById (R.id.star);
		 deathBar = (ProgressBar) ((Activity)context).findViewById (R.id.deathStatus);
		 activeQ = quest;
		 this.context = context;
		 interactButton =  (Button)((Activity)context).findViewById(R.id.interactButton);
	    

	}
	
	public void setDeathBar(long progress){
		
		if(progress <= 60000){
			deathBar.setProgress((60000-(int)progress));
		}
	}
	
	public void showDeathBar(){
		deathBar.setVisibility(View.VISIBLE);
	}
	
	public void hideDeathBar(){
		deathBar.setVisibility(View.GONE);
	}

	
	public void setTimerText(String timer){
		timerText.setText(timer);
	}
	
	public void changeTimerColor(){
		timerText.setTextColor(Color.RED);
	}

	public void setSandbagText(String sandbag) {
		sandbagText.setText(sandbag);
	}
	
	public void hideSandbagImage() {
		this.sandbagImage.setVisibility(View.GONE);
	}
	
	public void showSandbagImage() {
		this.sandbagImage.setVisibility(View.VISIBLE);
	}
	

	public void showPointsImage() {
		this.pointsImage.setVisibility(View.VISIBLE);
	}
	
	
	public void setPointsText(String points) {
		pointsText.setText(points);
	}
	
	
	public void initButtons(final int activeID){
		
		final Button button = (Button)((Activity)context).findViewById(R.id.messageButton);
         button.setOnClickListener(new View.OnClickListener() {
             public void onClick(View v) {
            	 if(activeQ != null){
	            	 if(activeID== Quest.tutorialQuest){
	    				 tutorialSendMessageAction();
	    			 } else {
	    				 showMessagingDialog();
	    			 }	 
            	 }
             }
         });
		
     	final Button helpbutton =   (Button)((Activity)context).findViewById(R.id.helpButton);
     	helpbutton.setOnClickListener(new View.OnClickListener() {
             public void onClick(View v) {
            	 if(activeQ!=null){
            		 activeQ.showStartDialog();
            	 }
             }
         });
     	
    	interactButton.setOnClickListener(new View.OnClickListener() {
             public void onClick(View v) {
            	 if(activeQ!=null){
            		 activeQ.interact();
            	 }
             }
         });
    	

    	
    	if(activeQ!=null){
    		
    		
    	 if(activeID== Quest.floodProtectionQuest){
    		 if(activeQ.getSandbags() > 0){
    			 gotMoreSandbags();
    		 } else{
    			 noMoreSandbags();
    		 }
    		 }
    	 else if (activeID == Quest.monitorQuest){
    		 interactButton.setText("Start Evacuation");
    	 } 
    	 
    	 if(activeID != Quest.evacuationQuest){
    		 toggleInteractButton(true);
    	 }
    	
    	}
         

	}
	
	private void tutorialSendMessageAction(){

		if(activeQ.getPhase() == Tutorial.sandbagPlaced){				
        	  Intent intent = new Intent(context, GameFriendsActivity.class);
        	  intent.putExtra("fbid", activeQ.getPlayerid());
        	  intent.putExtra("tutorial", true);
        	  ((Activity)context).startActivityForResult(intent, GET_MESSAGE_TUTORIAL);        	  
		}
	}

	
    
    // Show dialog for sending a message
public void showMessageDialog(){
	   final EditText input = new EditText(context);
	   
	      new AlertDialog.Builder(context)
	          .setTitle("Send message to all")
	          .setView(input)
	          .setPositiveButton("Send", new DialogInterface.OnClickListener() {
	               public void onClick(DialogInterface dialog, int whichButton) {
	                   editable = input.getText();      
					activeQ.getHttphandler().sendMessageToAll(activeQ.getPlayerid(), editable.toString());
	                   Helper.displayText("Message sent to all", context, true);
	               }
	          })
	          .setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
	               public void onClick(DialogInterface dialog, int whichButton) {
	                      // Do nothing.
	               }
	          }).show();
 } // end showMessageDialog
   
	
		
public void sendMessageAction(){
	        	  Intent intent = new Intent(context, GameFriendsActivity.class);
	        	  intent.putExtra("fbid", activeQ.getPlayerid());
	        	  ((Activity)context).startActivity(intent);        	  
		}
		
		public void showInboxAction(){
      	  Intent intent = new Intent(context, InboxActivity.class);
      	  intent.putExtra("playerID", activeQ.getPlayerid());
      	((Activity)context).startActivity(intent);        	  
	}
		
	    // Show dialog for sending message
		public void showMessagingDialog(){
			  new AlertDialog.Builder(context)
	          .setTitle("Messages")
	          .setPositiveButton("Message all", new DialogInterface.OnClickListener() {
	                   public void onClick(DialogInterface dialog, int id) {
	                	   showMessageDialog();
	                   }
	               }).setNeutralButton("Friends", new DialogInterface.OnClickListener() {
	                   public void onClick(DialogInterface dialog, int id) {
	                	   sendMessageAction();
	                   }
	               })
	               .setNegativeButton("Inbox", new DialogInterface.OnClickListener() {
	                   public void onClick(DialogInterface dialog, int id) {
	                	   showInboxAction();
	                   }
	               }).show();
			
		}
		
		public void toggleInteractButton(boolean visible){
			if(visible){
				interactButton.setVisibility(View.VISIBLE);
			} else{
				
				interactButton.setVisibility(View.GONE);
			}
		}
		
		public void noMoreSandbags(){
			interactButton.setText("No more sandbags!");
			interactButton.setBackgroundResource(R.drawable.bottom_bar_dead);
		}
		
		public void gotMoreSandbags(){
			interactButton.setText("Place Sandbag Wall");
			interactButton.setBackgroundResource(R.drawable.bottom_bar);
		}
		
		
		public void setDeathDisplay(){
			interactButton.setText("You are dead!");
			interactButton.setBackgroundResource(R.drawable.bottom_bar_dead);
		}
		
		public void setAliveDisplay(){
			interactButton.setText("Notify");
			interactButton.setBackgroundResource(R.drawable.bottom_bar);
		}


	
}

