package com.flooded.gameEntities;

import java.util.ArrayList;
import java.util.Random;

import android.location.Location;
import android.util.Log;

import com.google.android.gms.maps.model.LatLng;

public class NPC {

	
	public enum State{
		Dead, Injured, Dehydrated;
	}
	
	
	
	LatLng location;
	private State state;
	
	
	public NPC(LatLng location) {
		this.location = location;
		setRandomState();
	}
	

	
	
	public void setState(State state) {
		this.state = state;
	}
	
	public State getState() {
		return state;
	}
	
	public int getStateAsInt(){
		if(state == State.Injured){
			return 0;
		} else if(state == State.Dehydrated){
			return 1;
		} else{
			return 2;
		}
	}
	

	public void setStateFromInt(int number){
		if(number == 0){
			setState(State.Injured);
		} else if(number == 1){
			setState(State.Dehydrated);
		} else{
			setState(State.Dead);
		}
	}
	
	public void setRandomState(){
		Random rn = new Random();
		int number = rn.nextInt(3);
		setStateFromInt(number);
		
	}
	
	public boolean isInjured(){
		if(state == State.Injured){
			return true;
		} else {
			return false;
		}
	}
	
	

	public boolean isDead() {
		if(getState() == State.Dead){
			return true;
		} else{
			return false;
		}
	}
	
	public void setDead() {
		setState(State.Dead);
	}
	
	public boolean inRangeOfPoint(LatLng point, int distance){
		float[] results = new float[3];
		Location.distanceBetween(location.latitude, location.longitude, point.latitude, point.longitude, results);
		float meters = results[0];
		
		if(meters < distance){
			return true;
		}
		else{
			return false;
		}
	}
	
	public boolean inRangeOfPoint(Location loc, int distance){
		float[] results = new float[3];
		Location.distanceBetween(location.latitude, location.longitude, loc.getLatitude(), loc.getLongitude(), results);
		float meters = results[0];
		Log.w("Avstand i meter til NPC " + meters, "Debug " + meters);
		
		if(meters < distance){
			return true;
		}
		else{
			return false;
		}
	}
	
	
	public double getLongitude(){
		return location.longitude;
	}
	public double getLatitude(){
		return location.latitude;
	}
}
