package com.flooded.gameEntities;

public class Rank {

	public enum Level{
	 	 FIRST(0, "Civilian"), SECOND(100, "Novice Volunteer"), THIRD(500, "Volunteer"), FOURTH(1000, "Skilled Volunteer"), FIFTH(3000, "Expert Volunteer");
	 	 
	 	 private final int value;
	 	private final String title;
	 	 
	 	 private Level(int value, String title) {
	 		 this.value = value;
	 		 this.title = title;
		}
	 	
	 	 public int getValue() {
			return value;
		}
	 	 
	 	 public String getTitle() {
			return title;
		}
	 	
	}
	
	
	private String currentTitle;
	
	public Rank(int pts) {
		currentTitle = computeTitle(pts);
	}
	
	public String getCurrentTitle() {
		return currentTitle;
	}
	
	public void setCurrentTitle(String currentTitle) {
		this.currentTitle = currentTitle;
	}
	
	public int pointsForNext(){
		int temp = 0;
		if(getCurrentTitle().equals(Level.FIRST.title)){
			temp = Level.SECOND.getValue();
		}
		else if(getCurrentTitle().equals(Level.SECOND.title)){
			temp = Level.THIRD.getValue();
		}
		else if(getCurrentTitle().equals(Level.THIRD.title)){
			temp = Level.FOURTH.getValue();
		}
		else if(getCurrentTitle().equals(Level.FOURTH.title)){
			temp = Level.FIFTH.getValue();
		} else {
			temp = 5000;
		}
		return temp;
	}
	
	public String computeTitle(int pts){
		String title = "";
		if(pts >= Level.FIFTH.getValue()){
			title = Level.FIFTH.getTitle();
		}
		else if(pts >= Level.FOURTH.getValue()){
			title = Level.FOURTH.getTitle();
		}
		else if(pts >= Level.THIRD.getValue()){
			title =  Level.THIRD.getTitle();
		}
		else if(pts >= Level.SECOND.getValue()){
			title =  Level.SECOND.getTitle();
		} else{
			title = Level.FIRST.getTitle();
		}
		setCurrentTitle(title);
		return title;
	}
	
	public String levelUp(int pts){
		String title = computeTitle(pts);
		if(title.equals(currentTitle)){
			return "";
		} else{
			currentTitle = title;
			return title;
		}
	}


	
	
	
}
