package com.flooded.gameEntities;

import java.util.ArrayList;
import java.util.List;

import android.graphics.Color;
import android.location.Location;
import android.util.Log;

import com.flooded.helperClasses.GreatCircle;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Polyline;
import com.google.android.gms.maps.model.PolylineOptions;

public class River {
	
	List<RiverLine> rivers;
	GoogleMap map;

	static int R = 6371000; // m
	
	public River(GoogleMap map) {
		rivers = new ArrayList<RiverLine>();
		this.map = map;
	}
	
	public void addRivers(){

		
		RiverLine southRiverLine = new RiverLine(new LatLng(63.426752,10.402658), new LatLng(63.425615,10.402615));
		rivers.add(southRiverLine);


		southRiverLine = southRiverLine.getNext(new LatLng(63.425466,10.40235), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.425291,10.402103), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.425173,10.401969), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.42501,10.401733), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.424864,10.401513), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.424684,10.401303), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.424518,10.401057), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.424377,10.40081), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.42423,10.400552), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.424055,10.400255), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.42387,10.399717), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423733,10.399249), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423617,10.398845), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423529,10.398471), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423417,10.397972), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423318,10.397495), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423265,10.396953), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423263,10.396325), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423265,10.395809), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423283,10.395391), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423293,10.394996), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423319,10.394572), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.42334,10.394256), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423333,10.393858), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423371,10.393529), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423429,10.393246), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423476,10.392877), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423645,10.391889), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423683,10.391617), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(63.423721,10.391331), rivers);
		southRiverLine = southRiverLine.getNext(new LatLng(	63.423762,10.391072), rivers);
	
		
		
//		southRiverLine = southRiverLine.getNext(new LatLng(63.424377,10.40081), rivers);
//		southRiverLine = southRiverLine.getNext(new LatLng(63.424055,10.400255), rivers);
//		southRiverLine = southRiverLine.getNext(new LatLng(63.423592,10.398873), rivers);
//		southRiverLine = southRiverLine.getNext(new LatLng(63.423318,10.397495), rivers);
//		southRiverLine = southRiverLine.getNext(new LatLng(63.423265,10.396953), rivers);
//		southRiverLine = southRiverLine.getNext(new LatLng(63.423253,10.396175), rivers);
//		southRiverLine = southRiverLine.getNext(new LatLng(63.423333,10.393858), rivers);
//		southRiverLine = southRiverLine.getNext(new LatLng(63.423721,10.391331), rivers);
			
	}
	
	public double getDistanceToRivers(LatLng point){
		
		double tempdistance = 0;
		double distance = Double.MAX_VALUE;
		
		for(RiverLine river: rivers){
			tempdistance = GreatCircle.computeDistance(point, river.getStartPoint());
		
					
					//getDistanceToLine(point, river.getStartPoint(), river.getEndPoint());
		
			
			if (tempdistance < distance){
				distance = tempdistance;
			}
		}
		Log.w("closest distance " + distance, "river");
		return distance;
	}
	
	public double getDistanceToLine(LatLng point, LatLng from, LatLng to){
		
		float[] result = new float[3];
		Location.distanceBetween(from.latitude, from.longitude, point.latitude, point.longitude, result);
		double d13 = result[0];
		double b12 = getBearing(from, to);
		double b13 = getBearing(from, point);
		
//		
//		Log.w("distanceFromPointToStart " + d13, "river");
//		Log.w("bearingFromStartPointToPoint " + b13, "river");
//		Log.w("bearingFromStartPointToEndPoint " + b12, "river");
		
		double distance = Math.asin(
				Math.sin(d13/R)
				*Math.sin(Math.toRadians(b13)-Math.toRadians(b12))
				)*R;				
		if(distance < 0){
			distance =  0 - distance;
		}
		
		Log.w("distance " + distance, "river");
		return distance;
	}

	private double getBearing(LatLng startPoint, LatLng point) {
		

        double dLon =  Math.toRadians(point.longitude - startPoint.longitude);
		
		double lat1 = Math.toRadians(startPoint.latitude);
		double lat2 = Math.toRadians(point.latitude);
		
		double y = Math.sin(dLon) * Math.cos(lat2);
		double x = Math.cos(lat1)*Math.sin(lat2) -
		        Math.sin(lat1)*Math.cos(lat2)*Math.cos(dLon);
	    double brng = Math.atan2(y, x);
	    double result = Math.toDegrees(brng);

	    return (result+360) % 360;
	}

	public void writeLog(String message){
		Log.w(message, "river" );
		
	}
	
	private class RiverLine{
		private LatLng startPoint, endPoint;
		private Polyline line;
		
		public RiverLine(LatLng start, LatLng end) {
			this.startPoint = start;
			this.endPoint = end;
//			line = map.addPolyline(new PolylineOptions()
//		     .add(start, end)
//		     .width(1)
//		     .color(Color.RED)
//		     .visible(true)
//		     );
		}
		
		public RiverLine getNext(LatLng end, List<RiverLine> rivers){
			RiverLine nextRiverLine = new RiverLine(endPoint, end);
			rivers.add(nextRiverLine);
			return nextRiverLine;
		}
		
		public LatLng getStartPoint() {
			return startPoint;
		}
		public LatLng getEndPoint() {
			return endPoint;
		}
	}
}
