package com.flooded.gameEntities;

import java.util.ArrayList;
import java.util.Random;

import android.util.Log;

import com.google.android.gms.maps.model.LatLng;

public class RiverZone extends Zone{

	private int zoneScore;
	
	public RiverZone(LatLng nW, double length, double height) {
		super(nW, length, height);
	
	}
	
	public RiverZone(LatLng nW, LatLng nE, LatLng sE, LatLng sW) {
		super(nW, nE, sE, sW);
	}
	
	
	public int getZoneScore() {
		return zoneScore;
	}
	
	public void setZoneScore(int zoneScore) {
		this.zoneScore = zoneScore;
	}
	
	public int computeZoneScore(ArrayList<Sandbag> sandbags,  int zoneIndex, int numOfZones, int maxSandbags){
		int count = 0;
		double optimal = Math.floor((double)maxSandbags/(double)numOfZones);
		
		for(Sandbag sandbag : sandbags){
			if(sandbag.getZonePlacedIn()==zoneIndex){
				count++;
			}
		}
		
		double percentage = ((double)count/optimal);
	
		Log.w("Zone: " +zoneIndex + "  Number of sandbags: " + count + "  Optimal: " + optimal + "  percentage: " + percentage, "debug");
		
		if(percentage > 1){
			percentage = 1;
		}
		
		int score = (int)(percentage*100);
		Log.w("SCORE IS " + score, "debug flooded");
		setZoneScore(score);
		
		return score;
	
	}
	

	public RiverZone getNewZone(Direction direction){
		switch(direction){
		case North:
			RiverZone newZoneNorth = getNewZone(true, false, false, false);
			return newZoneNorth;
		case South:
			RiverZone newZoneSouth = getNewZone(false, true, false, false);
			return newZoneSouth;
		case East:
			RiverZone newZoneEast = getNewZone(false, false, false, true);
			return newZoneEast;
		case West:
			RiverZone newZoneWest = getNewZone(false, false, true, false);
			return newZoneWest;
		case SouthEast:
			RiverZone newZoneSouthEast = getNewZone(false, true, false, true);
			return newZoneSouthEast;
		case SouthWest:
			RiverZone newZoneSouthWest = getNewZone(false, true, true, false);
			return newZoneSouthWest;
		case NorthEast:
			RiverZone newZoneNorthEast = getNewZone(true, false, false, true);
			return newZoneNorthEast;
		case NorthWest:
			RiverZone newZoneNorthWest = getNewZone(true, false, true, false);
			return newZoneNorthWest;
		default:
			RiverZone newZoneNorth2 = getNewZone(true, false, false, false);
			return newZoneNorth2;
		}
	}
	
	
	public RiverZone getNewZone(Boolean north, Boolean south, Boolean west, Boolean east, double newLat, double newLong){
		
		if(!west && !east && !south && !north){
			east = true;
		}
		if(north && south){
			south = false;
		}
		if(east && west){
			east = false;
		}
		
		LatLng newNorthWest, newNorthEast,  newSouthWest, newSouthEast;
		Double newLatNorth, newLatSouth;
		Double newLongWest, newLongEast;
		Double length = northEast.longitude - northWest.longitude;
		Double height = northWest.latitude - southWest.latitude;
		
		if(west){
			newLongEast = northWest.longitude;
			newLongWest = northWest.longitude - length;
		}else if(east){
			newLongWest = northEast.longitude;
			newLongEast = northEast.longitude + length;
		}
		else{
			newLongEast = northEast.longitude;
			newLongWest = northWest.longitude;
		}

		if(north){
			newLatSouth = northWest.latitude;
			newLatNorth = northWest.latitude + height;
		}
		else if (south){
			newLatNorth = southWest.latitude;
			newLatSouth = southWest.latitude - height;
		} else{
			newLatNorth = northWest.latitude;
			newLatSouth = southWest.latitude;
		}
		
		newNorthWest = new LatLng(newLatNorth, newLongWest);
		newNorthEast = new LatLng(newLatNorth, newLongEast);
		newSouthWest = new LatLng(newLatSouth, newLongWest);
		newSouthEast = new LatLng(newLatSouth, newLongEast);
		return new RiverZone(newNorthWest, newNorthEast, newSouthEast, newSouthWest);
	}

	public RiverZone getNewZone(Boolean north, Boolean south, Boolean west, Boolean east){
		
		if(!west && !east && !south && !north){
			east = true;
		}
		if(north && south){
			south = false;
		}
		if(east && west){
			east = false;
		}
		
		LatLng newNorthWest, newNorthEast,  newSouthWest, newSouthEast;
		Double newLatNorth, newLatSouth;
		Double newLongWest, newLongEast;
		Double length = northEast.longitude - northWest.longitude;
		Double height = northWest.latitude - southWest.latitude;
		if(west){
			newLongEast = northWest.longitude;
			newLongWest = northWest.longitude - length;
		}else if(east){
			newLongWest = northEast.longitude;
			newLongEast = northEast.longitude + length;
		}
		else{
			newLongEast = northEast.longitude;
			newLongWest = northWest.longitude;
		}

		if(north){
			newLatSouth = northWest.latitude;
			newLatNorth = northWest.latitude + height;
		}
		else if (south){
			newLatNorth = southWest.latitude;
			newLatSouth = southWest.latitude - height;
		} else{
			newLatNorth = northWest.latitude;
			newLatSouth = southWest.latitude;
		}
		newNorthWest = new LatLng(newLatNorth, newLongWest);
		newNorthEast = new LatLng(newLatNorth, newLongEast);
		newSouthWest = new LatLng(newLatSouth, newLongWest);
		newSouthEast = new LatLng(newLatSouth, newLongEast);
		return new RiverZone(newNorthWest, newNorthEast, newSouthEast, newSouthWest);
	}
	
}
