package com.flooded.gameEntities;

import java.util.ArrayList;

import android.location.Location;
import android.util.Log;

import com.google.android.gms.maps.model.LatLng;

public class Sandbag extends QuestObject{

	
	private int distanceScore;
	private int finalScore;
	private int zoneScore;
	private int zonePlacedIn;
	
	public Sandbag(double latitude, double longitude) {
		super(latitude, longitude);
		this.distanceScore = 0;
		this.finalScore = 0;
		this.zoneScore = 0;
		zonePlacedIn = 0;
		this.setCrate(false);
		setType(0);
		// TODO Auto-generated constructor stub
	}
	
	public Sandbag(double latitude, double longitude, int id) {
		super(latitude, longitude);
		this.distanceScore = 0;
		this.finalScore = 0;
		this.zoneScore = 0;
		zonePlacedIn = 0;

		
		this.setCrate(false);
		setType(0);
		this.setId(id);
		// TODO Auto-generated constructor stub
	}
	
	
	public void setZonePlacedIn(int zonePlacedIn) {
		this.zonePlacedIn = zonePlacedIn;
	}
	
	public int getZonePlacedIn() {
		return zonePlacedIn;
	}
	
	public void computeZonePlacedIn(ArrayList<RiverZone> zones){
		int index = -1;
		for(int i = 0; i < zones.size();i++){
			if(zones.get(i).containsPoint(this.getLatitude(),this.getLongitude())){
				index = i;
			}
		}
		setZonePlacedIn(index);
	}
	
	public void setDistanceScore(int distanceScore) {
		this.distanceScore = distanceScore;
	}
	
	public void setFinalScore(int finalScore) {
		this.finalScore = finalScore;
	}
	
	
	public void setZoneScore(int zoneScore) {
		this.zoneScore = zoneScore;
	}
	
	public int getZoneScore() {
		return zoneScore;
	}
	public int getDistanceScore() {
		return distanceScore;
	}
	
	public int getFinalScore() {
		return finalScore;
	}
	
	public int computeDistanceScore(double distance){
		double maxScore = 55;
		if(distance < 5 && distance > 0){
			distance = 5;
		} else if(distance < 0){
			distance = 55;
		}
		
		int score = (int)(maxScore-distance);
		if(score < 0){
			score = 0;
		}
		setDistanceScore(score);
		return score;
	}
	
	public int getNumberOfCloseSandbags(ArrayList<Sandbag> sandbags){
		int number = 0;
		for(Sandbag otherSandbag: sandbags){
			if(!otherSandbag.equals(this)){
				if(inRangeOfSandbag(otherSandbag, 10)){
					number++;
				}
			}
		}
		return number;
	}

		
public boolean inRangeOfSandbag(Sandbag otherS, int distance){
		
		float[] results = new float[3];
		float meters;
		Location.distanceBetween(this.getLatitude(), this.getLongitude(), otherS.getLatitude(), otherS.getLongitude(), results);
		
		meters = results[0];		
		if(meters < distance){
			Log.w(Float.toString(meters), "Mindre enn "+distance);
			return true;
		}
		else{
			Log.w(Float.toString(meters), "Mer enn "+distance);
			return false;
		}	
	}
	
			
}
