package com.flooded.gameEntities;

import java.util.Calendar;

import android.util.Log;

import com.flooded.quests.Quest;

public class Session {

	private int id;
	
	private int score;
	private int numOfDeaths;
	private boolean finished;
	private long timeStarted;
	private long currentTime;
	private long extraEvacTime;
	private long fbid;
	
	public void setFbid(long fbid) {
		this.fbid = fbid;
	}
	
	public long getFbid() {
		return fbid;
	}
	
	public void setExtraEvacTime(long extraEvacTime) {
		this.extraEvacTime = extraEvacTime;
	}
	
	public int getNumOfDeaths() {
		return numOfDeaths;
	}
	
	public void setNumOfDeaths(int numOfDeaths) {
		this.numOfDeaths = numOfDeaths;
	}
	
	public long getExtraEvacTime() {
		return extraEvacTime;
	}
	
	public Session(long timeStarted) {
		this.timeStarted = timeStarted;
	}
	
	public long getTimeStarted() {
		return timeStarted;
	}
	public int getId() {
		return id;
	}
	public int getScore() {
		return score;
	}
	public boolean isFinished() {
		return finished;
	}
	public void setFinished(boolean finished) {
		this.finished = finished;
	}
	public void setScore(int score) {
		this.score = score;
	}
	public void setId(int id) {
		this.id = id;
	}
	
	public long getCurrentTime() {
		return currentTime;
	}
	
	public void setCurrentTime(long currentTime) {
		this.currentTime = currentTime;
	}
	
	public boolean isSessionOld(){
		Calendar calNow = Calendar.getInstance();
    	long timeNow = calNow.getTimeInMillis();
    	
    	if(timeNow - getTimeStarted() > Quest.totalGameDuration){
    		Log.w("Minutes since game started: " + ((timeNow-getTimeStarted()))/60000 + " ", "debug");
    		Log.w("Minutes since game ended: " + (((timeNow-getTimeStarted())-Quest.totalGameDuration))/60000 + " ", "debug");
    		return true;
    	} else{ 
    		Log.w("Minutes since game started: " + (((timeNow-getTimeStarted())))/60000 + " ", "debug");
    		Log.w("Minutes left: " + ((Quest.totalGameDuration-(timeNow-getTimeStarted())))/60000 + " ", "debug");
    		return false;
    	}
    	
	}
	
	public int getCurrentQuest(){
		Calendar calNow = Calendar.getInstance();
    	long timeNow = calNow.getTimeInMillis();
    	long timeSinceStarted = timeNow - getTimeStarted();

		if(timeSinceStarted < Quest.floodProtectionQuestDuration){
			return 1;
		} else if(timeSinceStarted < Quest.floodProtectionQuestDuration + Quest.monitorQuestDuration){
			long totalTimeOfFirstTwoQuests = (Quest.floodProtectionQuestDuration + Quest.monitorQuestDuration - getExtraEvacTime());
			if(totalTimeOfFirstTwoQuests < timeSinceStarted){
				return 5;
			} else {
				return 4;	
			}
		} else if(timeSinceStarted < Quest.floodProtectionQuestDuration + Quest.monitorQuestDuration + Quest.evacDuration){
			return 5;
		} else if(timeSinceStarted < Quest.totalGameDuration){
			return 2;
		} else{
			Log.w("-1", "debug");
			return -1;
		}
	}
	
	
	
	public long getQuestTimeRemaining(){
		long timeSinceStarted = getCurrentTime() - getTimeStarted();
		long timeRemainingOfQuest = 0L;
		
		if(timeSinceStarted < Quest.floodProtectionQuestDuration){
			
			timeRemainingOfQuest =  Quest.floodProtectionQuestDuration-timeSinceStarted;
			
		} else if(timeSinceStarted < Quest.floodProtectionQuestDuration + Quest.monitorQuestDuration){
			
			timeRemainingOfQuest = (Quest.floodProtectionQuestDuration + Quest.monitorQuestDuration)-timeSinceStarted;
			
			long totalTimeOfFirstTwoQuests = (Quest.floodProtectionQuestDuration + Quest.monitorQuestDuration - getExtraEvacTime());
			if(totalTimeOfFirstTwoQuests < timeSinceStarted){
				timeRemainingOfQuest = Quest.evacDuration+getExtraEvacTime() - (timeSinceStarted-totalTimeOfFirstTwoQuests);
			}
			
		} else if(timeSinceStarted < Quest.floodProtectionQuestDuration + Quest.monitorQuestDuration + Quest.evacDuration){
			
			timeRemainingOfQuest =  (Quest.floodProtectionQuestDuration + Quest.monitorQuestDuration + Quest.evacDuration)-timeSinceStarted;
			
		} else {
			
			timeRemainingOfQuest =  Quest.totalGameDuration-timeSinceStarted;
		}
		
		return timeRemainingOfQuest;
	}
	
}
