package com.flooded.gameEntities;

import java.util.Random;


public class WaterLevel extends QuestObject {

	private double currentWaterLevel, normalWaterLevel;

	
	public double getWaterLevel() {
		return currentWaterLevel;

	}

	public void setWaterLevel(double waterLevel) {
		this.currentWaterLevel = waterLevel;
	}

	public double getRandomWaterLevel(){
		Random r = new Random();
		return 5 + (20-5)*r.nextDouble();
	}
	
	public double getRandomWaterIncrease(boolean critical){
		Random r = new Random();
		double max, min;
		if(critical){
			min = 3;
			max = 7;
		}
		else {
			min = 0.1;
			max = 2.99;
		}
		return min + (max-min)*r.nextDouble();
	}
	
	public double getNormalWaterLevel() {
		return normalWaterLevel;
	}
	
	public double getDifference() {
		return (getWaterLevel() - getNormalWaterLevel());
	}
	
	public WaterLevel(double latitude, double longitude) {
		super(latitude, longitude);
		this.normalWaterLevel = getRandomWaterLevel();
		setWaterLevel(getNormalWaterLevel() + getRandomWaterIncrease(false));
		this.setCrate(false);
		setType(1);
	}
	
	public void setCritical(){
		setWaterLevel(getNormalWaterLevel() + getRandomWaterIncrease(true));
	}
	
	public boolean isCritical(){
		if(getWaterLevel() - getNormalWaterLevel() > 2.99){
			return true; 
		} else{
			return false;
		}
	}
}
