package com.flooded.helperClasses;

import com.flooded.R;
import com.flooded.quests.Quest;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Color;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;


/* Class that has simple AlertDialogs that only contains a message
 * 
 */

public class Dialog {


    static String username = "";
	
    // Show dialog for finished SNR quest
	public static AlertDialog showFPStartedDialog(Context context){
		      AlertDialog ad = new AlertDialog.Builder(context)
		          .setTitle("Protect the area!")
		          .setMessage("Your area will soon be hit by an impending flood! " +
		          		"Only you and other volunteers can help protect the area. " +
		          		"Cooperate to cover critical areas with sandbags to limit the damages of the flood. " +
		          		"Good luck!")
		          		.setCancelable(false)
		          		.setPositiveButton("OK", new DialogInterface.OnClickListener() {
		                   public void onClick(DialogInterface dialog, int id) {
		                   }})   
		          		.show();
		      
		      return ad;
	 } // end showSNR

    // Show dialog for finished SNR quest
	public static void showFPSEndedDialog(Context context, int score, final Quest q){
		      new AlertDialog.Builder(context)
		          .setTitle("Quest finished")
		          .setMessage("The total flood score of your group was " + score + "%!")
		          .setCancelable(false)
		          		.setPositiveButton("OK", new DialogInterface.OnClickListener() {
		                   public void onClick(DialogInterface dialog, int id){
		                	   q.restartActivity();
		                   }})   
		          		.show();
	 } // end showSNR
	
	
	// Show dialog for finished SNR quest
 public static AlertDialog showSNRStartedDialog(Context context){
	      AlertDialog ad = new AlertDialog.Builder(context)
	          .setTitle("Search and rescue!")
	          .setCancelable(false)
	          .setMessage("A group of people have gone missing in the area. You and the other volunteers must try to find them! " +
	          		"Each zone contains one missing person (NPC). When you rescue an NPC, you must give a correct notification. " +
	          		"A green zone denotes a cleared zone, while a red zone is yet to be searched!")
	          		.setPositiveButton("OK", new DialogInterface.OnClickListener() {
	                   public void onClick(DialogInterface dialog, int id) {
	                   }})   
	          		.show();
	      return ad;
 } // end showSNR

	
	
	// Show dialog for finished SNR quest
public static void displayRescueDialog(Context context, int state){
		String message = "";
		if(state == 0){
			message = "The person tells you that he is injured and in need of medical assistance." +
					" Please notify the correct authorities so that he can get help.";
					
		} else if (state == 1){
			message = "The person tells you that he is dehydrated and in need of water." +
					" Please notify the correct authorities so that he can get help.";
		} else{
			message = "The person is dead." +
					" Please notify the correct authorities of his death.";
		}
	
	      new AlertDialog.Builder(context)
	          .setTitle("Person needs help!")
	          .setCancelable(false)
	          .setMessage(message)
	          		.setPositiveButton("OK", new DialogInterface.OnClickListener() {
	                   public void onClick(DialogInterface dialog, int id) {
	                   }})   
	          		.show();
} // end showSNR

		
 	
 // Show dialog for finished SNR quest
public static void showMonitorFinishedDialog(Context context, final Quest quest){
	      new AlertDialog.Builder(context)
	          .setTitle("Quest finished!")
	          .setMessage("Time is up")
	          .setCancelable(false)
	          .setPositiveButton("OK", new DialogInterface.OnClickListener() {
	                   public void onClick(DialogInterface dialog, int id) {
	                	   quest.restartActivity();
	           }})
	          .show();
} // end showSNR


// Show dialog for finished SNR quest
public static AlertDialog showEvacuationStarted(Context context){
      AlertDialog ad =new AlertDialog.Builder(context)
          .setTitle("Evacuate!")
          .setMessage("Run to the evacuation zone before the time runs out!")
          .setCancelable(false)
          		.setPositiveButton("OK", new DialogInterface.OnClickListener() {
                   public void onClick(DialogInterface dialog, int id) {
                   }})   
          		.show();
      return ad;
} // end showEvacStart


// Show dialog for finished Evac quest
public static void showEvacuationFinished(Context context, final Quest quest){

	
      new AlertDialog.Builder(context)
          .setTitle("Evacuation finished!")
          .setMessage("You survived!")
          .setCancelable(false)
          .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                   public void onClick(DialogInterface dialog, int id) {
                	   quest.restartActivity();
           }})   
          .show();
} // end showEvac




public static void setUsername(String username) {
	Dialog.username = username;
}

public static String getUsername() {
	return username;
}


	
}
