package com.flooded.helperClasses;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.SocketException;
import java.util.ArrayList;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import com.JSONParser.PlayerHolder;
import com.JSONParser.PlayerResponse;
import com.JSONParser.QuestHolder;
import com.JSONParser.QuestResponse;
import com.JSONParser.ZoneHolder;
import com.JSONParser.ZoneResponse;
import com.flooded.LeaderboardActivity;
import com.flooded.MapActivity;
import com.flooded.ProfileActivity;
import com.google.gson.Gson;
import com.google.gson.JsonSyntaxException;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.DialogInterface.OnCancelListener;
import android.location.Location;
import android.os.AsyncTask;
import android.util.Log;
import android.view.WindowManager.BadTokenException;
import android.app.Activity;
/*****
 * This is a helper class for fetching data from the database through PHP and Gson.
 * This class is also used to start new activities.
 * @author Sondre Mannsverk
 *
 */


public class HTTPHandler {

	public ProgressDialog progressDialog;
	private String id, zoneid;
	private String name, to, message;
	private String lng, lat;
	private int type, distance, questid, sessionid;
	private Context currentContext;
	private Location myLocation;
	private Boolean online;
	private String points, floodScore;
	
	public void setSessionid(int sessionid) {
		this.sessionid = sessionid;
	}
	public int getSessionid() {
		return sessionid;
	}
	
	public void setFloodScore(String floodScore) {
		this.floodScore = floodScore;
	}
	
	public void setDistance(int distance) {
		this.distance = distance;
	}
	public void setQuestid(int questid) {
		this.questid = questid;
	}
	
	public int getQuestid() {
		return questid;
	}
	
	public int getDistance() {
		return distance;
	}
	
	public String getFloodScore() {
		return floodScore;
	}
	
	public void setPoints(String points) {
		this.points = points;
	}public String getPoints() {
		return points;
	}
	
	public void setTo(String to) {
		this.to = to;
	}
	public void setMessage(String message) {
		this.message = message;
	}public String getTo() {
		return to;
	}public String getMessage() {
		return message;
	}
	
	public void setZoneid(String zoneid) {
		this.zoneid = zoneid;
	}
	public String getZoneid() {
		return zoneid;
	}
	
	public void setType(int type) {
		this.type = type;
	}
	
	public int getType() {
		return type;
	}
	
	public void setLat(String lat) {
		this.lat = lat;
	}
	public String getLat() {
		return lat;
	}
	public void setLng(String lng) {
		this.lng = lng;
	}
	public String getLng() {
		return lng;
	}
	
	public void setMyLocation(Location myLocation) {
		this.myLocation = myLocation;
	}
	
	public Location getMyLocation() {
		return myLocation;
	}
	
	public void setOnline(Boolean online) {
		this.online = online;
	}
	public Boolean getOnline() {
		return online;
	}
	public Context getCurrentContext() {
		return currentContext;
	}
	public void setCurrentContext(Context currentContext) {
		this.currentContext = currentContext;
	}
	
	public void setId(String tempID) {
		this.id = tempID;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getId() {
		return id;
	}
	public String getName() {
		return name;
	}
	
	public HTTPHandler() {
		// TODO Auto-generated constructor stub
	}
	
	 private class CancelListener implements OnCancelListener {

		  	AsyncTask<?, ?, ?> cancellableTask;
		  	
		  	public CancelListener(AsyncTask<?, ?, ?> task) {
		  		cancellableTask = task;
				}
		  	
				@Override
				public void onCancel(DialogInterface dialog) {
					cancellableTask.cancel(true);
				}
		  }
		 
	 
	 // Check if player exist in the database, if not call newPlayer()
	 
	  public void getPlayer(Context context, String id, String name) {
		  
		  this.setName(name);
		  this.setCurrentContext(context);
		  this.setId(id);
		  		  
		  
		  	try{
		  	progressDialog = ProgressDialog.show(currentContext,
		      		"Please wait...", "Retrieving data...", true, true);

		  	LoadPlayer task = new LoadPlayer();
		  	task.execute();
		  	progressDialog.setOnCancelListener(new CancelListener(task));
		  	}
		  	catch(BadTokenException e){
		  		e.printStackTrace();
		  	}
		  }
		  
		  private class LoadPlayer extends AsyncTask<Void, Void, Void> {

		  	PlayerResponse playerResponse;

		  	
				@Override
				protected Void doInBackground(Void... params) {
					String url ="";
					
					url = "http://sondre.mannsverk.no/restful.php?user="+id+"&name="+name;
					url = url.replace(" ", "%20");
					
		  		HttpGet getRequest = new HttpGet(url);
		  			  		try {
		  			DefaultHttpClient httpClient = new DefaultHttpClient();
		  			HttpResponse getResponse = httpClient.execute(getRequest);
		  			
		  			final int statusCode = getResponse.getStatusLine().getStatusCode();
		  			
		  			if (statusCode != HttpStatus.SC_OK) { 
		  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
		  	            return null;
		  	        }

		  			HttpEntity getResponseEntity = getResponse.getEntity();
		  			InputStream httpResponseStream = getResponseEntity.getContent();
		  			Reader inputStreamReader = new InputStreamReader(httpResponseStream);
		  			
		              Gson gson = new Gson();
		        
			              this.playerResponse = gson.fromJson(inputStreamReader, PlayerResponse.class);
			   
			  			  		
			  			  			  
		        
		  		} 
		  		catch (IOException e) {
		  			getRequest.abort();
		  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
		  		}

					return null;
				}
				
				@Override
				protected void onPostExecute(Void result) {
					super.onPostExecute(result);
					
					try{
						for (PlayerHolder player : this.playerResponse.data) {
							player.getFbid();
							Log.w("Player is in database", "Debug");
						}
					}
					catch (Exception e) {
						e.printStackTrace();
					}

			
					try{
				 progressDialog.cancel();
				  	}
				  	catch(IllegalArgumentException e){
				  		e.printStackTrace();
				  	}
		  }
		  } // end check if player exist
	 
	  
	 // Adds new player to the database
	 
	  void newPlayer(Context context, String id, String name) {
		  	
		  this.setName(name);
		  this.setId(id);
		  
		  	AddPlayerSpecificAsyncTask task = new AddPlayerSpecificAsyncTask();
		  	task.execute();
		  		
		  }
		  
		  private class AddPlayerSpecificAsyncTask extends AsyncTask<Void, Void, Void> {


				@Override
				protected Void doInBackground(Void... params) {
				  	String url = "http://sondre.mannsverk.no/player.php?player="+id+"&new="+name;
					url = url.replace(" ", "%20");
					
					HttpGet getRequest = new HttpGet(url);
		  			  		try {
		  			DefaultHttpClient httpClient = new DefaultHttpClient();
		  			Log.w("NewPlayer", "NewPlayer");
		  			HttpResponse getResponse = httpClient.execute(getRequest);
		  			
		  			final int statusCode = getResponse.getStatusLine().getStatusCode();
		  			
		  			if (statusCode != HttpStatus.SC_OK) { 
		  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
		  	            return null;
		  	        }
		  		} 
		  		catch (IOException e) {
		  			getRequest.abort();
		  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
		  		}
		  
					return null;
				}
		  } // end Add player

		  
		  // Resets all the sandbag quests
		  void refreshQuest(Context context) {
			  try{
			  	progressDialog = ProgressDialog.show(context,
			      		"Please wait...", "Retrieving data...", true, true);

			  	RefreshQuestSpecificAsyncTask task = new RefreshQuestSpecificAsyncTask();
			  	task.execute();
			  	progressDialog.setOnCancelListener(new CancelListener(task));
			  	}
			  	catch(BadTokenException e){
			  		e.printStackTrace();
			  	}
			  }
			  
			  private class RefreshQuestSpecificAsyncTask extends AsyncTask<Void, Void, Void> {


					@Override
					protected Void doInBackground(Void... params) {
					  	String url = "http://sondre.mannsverk.no/refreshquests.php";						
						HttpGet getRequest = new HttpGet(url);
			  			  		try {
			  			DefaultHttpClient httpClient = new DefaultHttpClient();
			  			HttpResponse getResponse = httpClient.execute(getRequest);
			  			
			  			final int statusCode = getResponse.getStatusLine().getStatusCode();
			  			
			  			if (statusCode != HttpStatus.SC_OK) { 
			  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
			  	            return null;
			  	        }
			  		} 
			  		catch (IOException e) {
			  			getRequest.abort();
			  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
			  		}
			  			  		try{
			  			progressDialog.cancel();
			  			    	}
							  	catch(IllegalArgumentException e){
							  		e.printStackTrace();
							  	}
						return null;
					}			
			  } // end refresh quest
			  
			  // Resets the SnR quest
			  public void refreshSNRQuest(Context context) {
				  
				  try{
				  	progressDialog = ProgressDialog.show(context,
				      		"Please wait...", "Retrieving data...", true, true);

				  	RefreshSNRQuestSpecificAsyncTask task = new RefreshSNRQuestSpecificAsyncTask();
				  	task.execute();
				  	progressDialog.setOnCancelListener(new CancelListener(task));
				  } catch(BadTokenException e){
				     e.printStackTrace();
				  }
			  }
				  
				  private class RefreshSNRQuestSpecificAsyncTask extends AsyncTask<Void, Void, Void> {


						@Override
						protected Void doInBackground(Void... params) {
						  	String url = "http://sondre.mannsverk.no/zone.php?refresh";						
							HttpGet getRequest = new HttpGet(url);
				  			  		try {
				  			DefaultHttpClient httpClient = new DefaultHttpClient();
				  			HttpResponse getResponse = httpClient.execute(getRequest);
				  			
				  			final int statusCode = getResponse.getStatusLine().getStatusCode();
				  			
				  			if (statusCode != HttpStatus.SC_OK) { 
				  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
				  	            return null;
				  	        }
				  		} 
				  		catch (IOException e) {
				  			getRequest.abort();
				  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
				  		}
				  			  		try{
				  			progressDialog.cancel();
				  			  		} 
				  			  		catch(IllegalArgumentException e){
				  			  			e.printStackTrace();
				  			  		}
							return null;
						}			
				  } // end refresh quest
			  
			  
			  // Set npc found in given zone
			  public void updateZone(Context context, String zone) {
				  
				    int zoneInt = Integer.parseInt(zone) + 1;
				  	this.zoneid = Integer.toString(zoneInt);
				  	
				  	try{
		

				  	UpdateZoneSpecificAsyncTask task = new UpdateZoneSpecificAsyncTask();
				  	task.execute();
				  	}
				  	catch(BadTokenException e){
				  		e.printStackTrace();
				  	}
				  }
				  
				  private class UpdateZoneSpecificAsyncTask extends AsyncTask<Void, Void, Void> {


						@Override
						protected Void doInBackground(Void... params) {
						  	String url = "http://sondre.mannsverk.no/zone.php?zoneid="+zoneid;						
							HttpGet getRequest = new HttpGet(url);
				  			  		try {
				  			DefaultHttpClient httpClient = new DefaultHttpClient();
				  			HttpResponse getResponse = httpClient.execute(getRequest);
				  			
				  			final int statusCode = getResponse.getStatusLine().getStatusCode();
				  			
				  			if (statusCode != HttpStatus.SC_OK) { 
				  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
				  	            return null;
				  	        }
				  		} 
				  		catch (IOException e) {
				  			getRequest.abort();
				  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
				  		}
				  			  	
							return null;
						}			
				  } // end update zone
				  
				  
				  
				  // Set npc found in given zone
				  public void changeUsername(Context context, String fbid, String name) {
					  
					  	this.id = fbid;
					  	this.name = name;
			
					  	ChangeUsernameAsyncTask task = new ChangeUsernameAsyncTask();
					  	task.execute();

					  }
					  
					  private class ChangeUsernameAsyncTask extends AsyncTask<Void, Void, Void> {


							@Override
							protected Void doInBackground(Void... params) {
							  	String url = "http://sondre.mannsverk.no/updateplayer.php?fbid="+getId()+"&username="+getName();				
								HttpGet getRequest = new HttpGet(url);
					  			  		try {
					  			DefaultHttpClient httpClient = new DefaultHttpClient();
					  			HttpResponse getResponse = httpClient.execute(getRequest);
					  			
					  			final int statusCode = getResponse.getStatusLine().getStatusCode();
					  			
					  			if (statusCode != HttpStatus.SC_OK) { 
					  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
					  	            return null;
					  	        }
					  		} 
					  		catch (IOException e) {
					  			getRequest.abort();
					  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
					  		}
					  			
								return null;
							}			
					  } // end update zone
				  
				  
				  
				  // Notify npc found in given zone
				  public void notifyZone(Context context, String zone, int id) {
					  
					  
					    int zoneInt = Integer.parseInt(zone) + 1;
					  	this.zoneid = Integer.toString(zoneInt);
					  	Log.w(id + " id", "debug");
					  	setId(Integer.toString(id));
					  	Log.w(getId() + " id2", "debug");
					  
					  	try{
					  	progressDialog = ProgressDialog.show(context,
					      		"Please wait...", "Retrieving data...", true, true);

					  	NotifyZoneSpecificAsyncTask task = new NotifyZoneSpecificAsyncTask();
					  	task.execute();
					  	progressDialog.setOnCancelListener(new CancelListener(task));
					  	}
					  	catch(BadTokenException e){
					  		e.printStackTrace();
					  	}
					  }
					  
					  private class NotifyZoneSpecificAsyncTask extends AsyncTask<Void, Void, Void> {


							@Override
							protected Void doInBackground(Void... params) {
							  	String url = "http://sondre.mannsverk.no/zone.php?zoneid="+zoneid+"&notify="+getId();						
								HttpGet getRequest = new HttpGet(url);
					  			  		try {
					  			DefaultHttpClient httpClient = new DefaultHttpClient();
					  			HttpResponse getResponse = httpClient.execute(getRequest);
					  			
					  			final int statusCode = getResponse.getStatusLine().getStatusCode();
					  			
					  			if (statusCode != HttpStatus.SC_OK) { 
					  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
					  	            return null;
					  	        }
					  		} 
					  		catch (IOException e) {
					  			getRequest.abort();
					  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
					  		}
					  			  try{
					  			progressDialog.cancel();
					  		  		}
								  	catch(IllegalArgumentException e){
								  		e.printStackTrace();
								  	}
								return null;
							}			
					  } // end notify zone
					  
				  
				  
				  
		
			  
				  
				  
				  // Return all data needed for game/map (quests, position of other players, player info, zones) 
				  // Starts mapActivity
				  
				  public void getQuests(Context context, String id) {
	
					  this.setCurrentContext(context);
					  this.id = id;
					  
					   try{
					  	progressDialog = ProgressDialog.show(context,
					      		"Please wait...", "Retrieving data...", true, true);

					  	QuestsRetrieverAsyncTask task = new QuestsRetrieverAsyncTask();
					  	task.execute();
					  	progressDialog.setOnCancelListener(new CancelListener(task));
					  	}
					  	catch(BadTokenException e){
					  		e.printStackTrace();
					  	}
					  }
					  
					  private class QuestsRetrieverAsyncTask extends AsyncTask<Void, Void, Void> {

						ZoneResponse zoneResponse;
					  	QuestResponse response;
					  	//PlayerResponse playerResponse;
					  	PlayerResponse playersResponse;

							@Override
							protected Void doInBackground(Void... params) {

								String url = "http://sondre.mannsverk.no/restful.php?quest=1";
								String url2 = "http://sondre.mannsverk.no/restful.php";
								String zoneurl = "http://sondre.mannsverk.no/zone.php";
								
					  		HttpGet getRequest = new HttpGet(url);
					  		HttpGet getPlayersRequest = new HttpGet(url2);
					  		HttpGet getZoneRequest = new HttpGet(zoneurl);
					  		
					  		try {
					  			DefaultHttpClient httpClient = new DefaultHttpClient();
					  			DefaultHttpClient httpClient2 = new DefaultHttpClient();
					  			DefaultHttpClient httpClient3 = new DefaultHttpClient();
					  			
					  			
					  			HttpResponse getResponse = httpClient.execute(getRequest);  			
					  			HttpResponse getPlayersResponse = httpClient2.execute(getPlayersRequest);
					  			HttpResponse getZoneResponse = httpClient3.execute(getZoneRequest);
					  			
					  			final int statusCode = getResponse.getStatusLine().getStatusCode();
					  			final int playersStatusCode = getPlayersResponse.getStatusLine().getStatusCode();
					  			final int zoneStatusCode = getZoneResponse.getStatusLine().getStatusCode();

					  			if (statusCode != HttpStatus.SC_OK || zoneStatusCode != HttpStatus.SC_OK || playersStatusCode != HttpStatus.SC_OK) { 
					  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url + " or " + playersStatusCode + "for URL " + url2 + " or " + zoneStatusCode + " for url" + zoneurl); 
					  	            return null;
					  	        }

					  			HttpEntity getResponseEntity = getResponse.getEntity();
					  			InputStream httpResponseStream = getResponseEntity.getContent();
					  			Reader inputStreamReader = new InputStreamReader(httpResponseStream);
					  			
					  			HttpEntity getPlayersResponseEntity = getPlayersResponse.getEntity();
					  			InputStream httpPlayersResponseStream = getPlayersResponseEntity.getContent();
					  			Reader inputPlayersStreamReader = new InputStreamReader(httpPlayersResponseStream);

					  			HttpEntity getZoneResponseEntity = getZoneResponse.getEntity();
					  			InputStream httpZoneResponseStream = getZoneResponseEntity.getContent();
					  			Reader inputZoneStreamReader = new InputStreamReader(httpZoneResponseStream);
					  			
		
			            	  Gson gson = new Gson();
				              this.response = gson.fromJson(inputStreamReader, QuestResponse.class);
				              this.playersResponse = gson.fromJson(inputPlayersStreamReader, PlayerResponse.class);
				              this.zoneResponse = gson.fromJson(inputZoneStreamReader, ZoneResponse.class);
					           
					  		} 
					  		catch (IOException e) {
					  			getRequest.abort();
					  			getZoneRequest.abort();
					  			getPlayersRequest.abort();
					  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
					  		}

								return null;
							}
							
							@Override
							protected void onPostExecute(Void result) {
								super.onPostExecute(result);

								Intent intent = new Intent(currentContext, MapActivity.class);					
								    
								ArrayList<String> questid = new ArrayList<String>();
								ArrayList<String> latitude = new ArrayList<String>();
								ArrayList<String> longitude = new ArrayList<String>();
								ArrayList<String> completed = new ArrayList<String>();
								ArrayList<String> taggedby = new ArrayList<String>();
								//String playerID = getIntent().getStringExtra("fbid");
								ArrayList<String> fbids = new ArrayList<String>();
								ArrayList<String> lat = new ArrayList<String>();
								ArrayList<String> longi = new ArrayList<String>();
								ArrayList<String> online = new ArrayList<String>();
								ArrayList<String> type =  new ArrayList<String>();
								ArrayList<String> pts =  new ArrayList<String>();
								ArrayList<String> sandbags =  new ArrayList<String>();
								ArrayList<String> npcfound =  new ArrayList<String>();
								ArrayList<String> notified =  new ArrayList<String>();
								
								
								boolean internetConnection = false;
								
								try{
								
									for (PlayerHolder player : this.playersResponse.data){
										if(!player.getFbid().equals(getId())){
											fbids.add(player.getFbid());
											lat.add(player.getLat());
											longi.add(player.getLongi());
											online.add(player.getOnline());
										} else{
											pts.add(player.getPoints());
											sandbags.add(player.getSandbags());
										}
									}
									
							
									for (QuestHolder quest : this.response.data) {
										latitude.add(quest.latitude);
										longitude.add(quest.longitude);
										completed.add(quest.completed);
										taggedby.add(quest.taggedby);
										type.add(quest.getType());
										questid.add(quest.getQuestID());
									}
									
	
									for (ZoneHolder zone : this.zoneResponse.data) {
										npcfound.add(zone.getNpcfound());
										notified.add(zone.getNotified());
									}
									
									internetConnection = true;
								
								} catch(NullPointerException e){
									Helper.displayText("No internet connection!", getCurrentContext(), true);
									e.printStackTrace();
								}
								try{ 
									progressDialog.cancel();	
								} catch (IllegalArgumentException e){
									e.printStackTrace();
								}
								
		
								if(internetConnection){
									intent.putExtra("fbid", id);
									intent.putStringArrayListExtra("latitude", latitude);
									intent.putStringArrayListExtra("longitude", longitude);
									intent.putStringArrayListExtra("iscomp", completed);
									intent.putStringArrayListExtra("fbids", fbids);
									intent.putStringArrayListExtra("lat", lat);
									intent.putStringArrayListExtra("longi", longi);
									intent.putStringArrayListExtra("online", online);
									intent.putStringArrayListExtra("taggedby", taggedby);
									intent.putStringArrayListExtra("type", type);
									intent.putStringArrayListExtra("points", pts);
									intent.putStringArrayListExtra("sandbags", sandbags);
									intent.putStringArrayListExtra("npcfound", npcfound);
									intent.putStringArrayListExtra("notified", notified);
									intent.putStringArrayListExtra("questid", questid);
									Log.w("Starting map activity", "Debug");
									currentContext.startActivity(intent);
								}
							}
					  } // end get game data
			  
					  
					  // Retrieve player data and start Leaderboard activity
					  
					  public void retrievePlayers(Context context) {
						  	
						   this.setCurrentContext(context);
						   
						  	PlayerRetrieverAsyncTask task = new PlayerRetrieverAsyncTask();
						  	task.execute();
						
						  }
						  
						  private class PlayerRetrieverAsyncTask extends AsyncTask<Void, Void, Void> {

						  	PlayerResponse response;

								@Override
								protected Void doInBackground(Void... params) {
									String url = "http://sondre.mannsverk.no/restful.php";
						  		HttpGet getRequest = new HttpGet(url);
						  	    Log.w("retrievePlayers", "Debug");	
						  		try {
						  			DefaultHttpClient httpClient = new DefaultHttpClient();
						  			HttpResponse getResponse = httpClient.execute(getRequest);
						  			
						  			final int statusCode = getResponse.getStatusLine().getStatusCode();
						  			
						  			if (statusCode != HttpStatus.SC_OK) { 
						  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
						  	            return null;
						  	        }

						  			HttpEntity getResponseEntity = getResponse.getEntity();
						  			InputStream httpResponseStream = getResponseEntity.getContent();
						  			Reader inputStreamReader = new InputStreamReader(httpResponseStream);
						  			
						              Gson gson = new Gson();
						              this.response = gson.fromJson(inputStreamReader, PlayerResponse.class);
						  		} 
						  		catch (IOException e) {
						  			getRequest.abort();
						  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
						  		}

									return null;
								}
								
								@Override
								protected void onPostExecute(Void result) {
									super.onPostExecute(result);			
								
									Intent intent = new Intent(currentContext, LeaderboardActivity.class);
									ArrayList<String> fbid = new ArrayList<String>();
									ArrayList<String> pts = new ArrayList<String>();
									ArrayList<String> name = new ArrayList<String>();

									
									int i = 1;
									
									boolean internetConnection = false;
									
									try{
										for (PlayerHolder player : this.response.data) {
	
											fbid.add(player.getFbid());
											pts.add(player.getPoints());
											name.add(player.getName());
											
											i = i+1;
											
										}
										internetConnection = true;
									} catch(NullPointerException e){
										Helper.displayText("No internet connection!", getCurrentContext(), true);
										e.printStackTrace();
									}
												
								
									if(internetConnection){
										intent.putStringArrayListExtra("players", fbid);
										intent.putStringArrayListExtra("points", pts);
										intent.putStringArrayListExtra("name", name);
										currentContext.startActivity(intent);
									}
								}
						  	
						  } // end retrieve players for leaderboard
						  
						  
						  // Get data for player profile 
						  // Start profile activity
						  
		  public void getPlayerInfo(Context context, String id) {
			  
			  this.setCurrentContext(context);
			  this.setId(id);
			  	try{
			  	progressDialog = ProgressDialog.show(currentContext,
			      		"Please wait...", "Retrieving data...", true, true);

			  	PlayerSpecificAsyncTask task = new 	PlayerSpecificAsyncTask();
			  	task.execute();
			  	progressDialog.setOnCancelListener(new CancelListener(task));
			  	}
			  	catch(BadTokenException e){
			  		e.printStackTrace();
			  	}
			  }
			  
			  private class PlayerSpecificAsyncTask extends AsyncTask<Void, Void, Void> {

				    	PlayerResponse playerResponse;
			  	
					@Override
					protected Void doInBackground(Void... params) {
						String url ="";
						
						url = "http://sondre.mannsverk.no/restful.php?user="+id;
						
			  		HttpGet getRequest = new HttpGet(url);
			  		
			  		try {

			  			DefaultHttpClient httpClient = new DefaultHttpClient();
			  			
			  			HttpResponse getResponse = httpClient.execute(getRequest);
			  			
			  			final int statusCode = getResponse.getStatusLine().getStatusCode();
			  			
			  			if (statusCode != HttpStatus.SC_OK) { 
			  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
			  	            return null;
			  	        }

			  			HttpEntity getResponseEntity = getResponse.getEntity();
			  			InputStream httpResponseStream = getResponseEntity.getContent();
			  			Reader inputStreamReader = new InputStreamReader(httpResponseStream);
			  			
			              Gson gson = new Gson();
			              this.playerResponse = gson.fromJson(inputStreamReader, PlayerResponse.class);
			  		} 
			  		catch (IOException e) {
			  			getRequest.abort();
			  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
			  		}

						return null;
					}
					
					@Override
					protected void onPostExecute(Void result) {
						super.onPostExecute(result);
						

						//StringBuilder builder = new StringBuilder();
						
						Intent intent = new Intent(currentContext, ProfileActivity.class);
				
						String fbid = "";
						String pts = "";
						String sandbags = "";
						
						String fullname = ""; 
						fullname = name;
						
						boolean internetConnection = false;
						
						try{
							for (PlayerHolder player : this.playerResponse.data) {
								fbid = player.getFbid();
								pts = player.getPoints();
								sandbags = player.getSandbags();
								if(!fullname.equals(null)){
									fullname = player.getName();
								}
							}
							internetConnection = true;
						}
						catch(NullPointerException e){
							Helper.displayText("No internet connection!", getCurrentContext(), true);
							e.printStackTrace();
						}
						try{
						progressDialog.cancel();
					  	}
					  	catch(IllegalArgumentException e){
					  		e.printStackTrace();
					  	}
						if(internetConnection){
							intent.putExtra("fbid", fbid);
							intent.putExtra("name", fullname);
							intent.putExtra("points", pts);
							intent.putExtra("sandbags", sandbags);
							currentContext.startActivity(intent);
						}
					}
			  	
			  } // end get data for profile / start profile activity
 
		  
			// Updates player's status and position  
		  public void updatePlayerPosition(Context context, Boolean online, Location player, String playerID) {
			  	
			  	this.setId(playerID);
			  	this.setCurrentContext(context);
			  	this.setOnline(online);
			  	this.setMyLocation(player);
			  
			  	UpdatePlayerPosition task = new UpdatePlayerPosition();
			  	task.execute();		
			  }
			  
			  private class UpdatePlayerPosition extends AsyncTask<Void, Void, Void> {


					@Override
					protected Void doInBackground(Void... params) {
						
						  if(!myLocation.equals(null)){
							  String url = "";
							  if(online){
								  url = "http://sondre.mannsverk.no/updateplayer.php?lat=" + myLocation.getLatitude() +"&lng=" + myLocation.getLongitude()
									+"&fbid=" + id;
								  Log.w(id + " " + myLocation.getLatitude() + " " + myLocation.getLongitude(),"debug");
							  }
							  else{
								  url = "http://sondre.mannsverk.no/updateplayer.php?lat=" + myLocation.getLatitude() +"&fbid=" + id;
							  }
							HttpGet getRequest = new HttpGet(url);
							
							try {
								DefaultHttpClient httpClient = new DefaultHttpClient();
								HttpResponse getResponse = httpClient.execute(getRequest);
								
								final int statusCode = getResponse.getStatusLine().getStatusCode();
								
								if (statusCode != HttpStatus.SC_OK) { 
						            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
						        }

							} 
							catch (IOException e) {
								getRequest.abort();
						        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
							}
						  }
						  else{
							  Log.w("null","debug");
						  }
						return null;
					}	
			  }	// end update position	
		  

				// Updates player's status
			  public void updatePlayerStatus(Context context, String id) {
				  	
				  	this.setId(id);
				  
				  	UpdatePlayerStatus task = new UpdatePlayerStatus();
				  	task.execute();	
				  }
				  
				  private class UpdatePlayerStatus extends AsyncTask<Void, Void, Void> {


						@Override
						protected Void doInBackground(Void... params) {
							
							String url = "http://sondre.mannsverk.no/updateplayer.php?fbid=" + id;
													
							HttpGet getRequest = new HttpGet(url);
				  			  		try {
				  			DefaultHttpClient httpClient = new DefaultHttpClient();
				  			Log.w("NewPlayer", "NewPlayer");
				  			HttpResponse getResponse = httpClient.execute(getRequest);
				  			
				  			final int statusCode = getResponse.getStatusLine().getStatusCode();
				  			
				  			if (statusCode != HttpStatus.SC_OK) { 
				  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
				  	            return null;
				  	        }
				  		} 
				  		catch (IOException e) {
				  			getRequest.abort();
				  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
				  		}
				  				
							return null;
						}
				  }	// end update position		
	  
				  
					// Updates session flood score
				  public void updateFloodScore(Context context, int floodscore, int id) {
					  	
					  	this.setFloodScore((Integer.toString(floodscore)));
					  	this.setId(Integer.toString(id));
					  
					  	updateFloodScoreAsyncTask task = new updateFloodScoreAsyncTask();
					  	task.execute();	
					  }
					  
					  private class updateFloodScoreAsyncTask extends AsyncTask<Void, Void, Void> {


							@Override
							protected Void doInBackground(Void... params) {
								
								String url = "http://sondre.mannsverk.no/session.php?id="+getId()+"&setscore=" + getFloodScore();
														
								HttpGet getRequest = new HttpGet(url);
					  			  		try {
					  			DefaultHttpClient httpClient = new DefaultHttpClient();
					  			Log.w("NewPlayer", "NewPlayer");
					  			HttpResponse getResponse = httpClient.execute(getRequest);
					  			
					  			final int statusCode = getResponse.getStatusLine().getStatusCode();
					  			
					  			if (statusCode != HttpStatus.SC_OK) { 
					  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
					  	            return null;
					  	        }
					  		} 
					  		catch (IOException e) {
					  			getRequest.abort();
					  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
					  		}
					  				
								return null;
							}
					  }	// end update flood score
					  
					  
						// Update session evac time
					  public void updateEvacTime(Context context, long evacTime, int id) {
						  	
						  	this.setPoints(Long.toString(evacTime));
						  	this.setId(Integer.toString(id));
						  
						  	updateEvacTimeAsyncTask task = new updateEvacTimeAsyncTask();
						  	task.execute();	
						  }
						  
						  private class updateEvacTimeAsyncTask extends AsyncTask<Void, Void, Void> {


								@Override
								protected Void doInBackground(Void... params) {
									
									String url = "http://sondre.mannsverk.no/session.php?id="+getId()+"&extraEvac=" + getPoints();
															
									HttpGet getRequest = new HttpGet(url);
						  			  		try {
						  			DefaultHttpClient httpClient = new DefaultHttpClient();
						  			Log.w("NewPlayer", "NewPlayer");
						  			HttpResponse getResponse = httpClient.execute(getRequest);
						  			
						  			final int statusCode = getResponse.getStatusLine().getStatusCode();
						  			
						  			if (statusCode != HttpStatus.SC_OK) { 
						  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
						  	            return null;
						  	        }
						  		} 
						  		catch (IOException e) {
						  			getRequest.abort();
						  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
						  		}
						  				
									return null;
								}
						  }	// end update extra evac time		
			
						  public void updateDeaths(Context context, int id) {
							  	
							  	this.setId(Integer.toString(id));
							  	UpdateDeaths task = new UpdateDeaths();
							  	task.execute();	
							  }
							  
							  private class UpdateDeaths extends AsyncTask<Void, Void, Void> {


									@Override
									protected Void doInBackground(Void... params) {
										
										String url = "http://sondre.mannsverk.no/session.php?id="+getId()+"&deaths";
																
										HttpGet getRequest = new HttpGet(url);
							  			  		try {
							  			DefaultHttpClient httpClient = new DefaultHttpClient();
							  			Log.w("NewPlayer", "NewPlayer");
							  			HttpResponse getResponse = httpClient.execute(getRequest);
							  			
							  			final int statusCode = getResponse.getStatusLine().getStatusCode();
							  			
							  			if (statusCode != HttpStatus.SC_OK) { 
							  	            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
							  	            return null;
							  	        }
							  		} 
							  		catch (IOException e) {
							  			getRequest.abort();
							  	        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
							  		}
							  				
										return null;
									}
							  }	// end update extra evac time		
					  
						  
				  
		// Increment sandbags
	  public void incrementSandbags(Context context, String id) {
		  	
		  	this.setId(id);
		  try{

		  	IncrementSandbagAsyncTask task = new IncrementSandbagAsyncTask();
		  	task.execute();

		  	}
		  	catch(BadTokenException e){
		  		e.printStackTrace();
		  	}
		  }
		  
		  private class IncrementSandbagAsyncTask extends AsyncTask<Void, Void, Void> {


				@Override
				protected Void doInBackground(Void... params) {
					
					String url = "http://sondre.mannsverk.no/restful.php?user=" + id +"&crate";
					HttpGet getRequest = new HttpGet(url);
					
					try {
						DefaultHttpClient httpClient = new DefaultHttpClient();
						HttpResponse getResponse = httpClient.execute(getRequest);
						
						final int statusCode = getResponse.getStatusLine().getStatusCode();
						
						if (statusCode != HttpStatus.SC_OK) { 
				            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
				        }

					} 
					catch (IOException e) {
						getRequest.abort();
				        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
					}
					try{
		  		    
				  	}
				  	catch(IllegalArgumentException e){
				  		e.printStackTrace();
				  	}
					return null;
				}
		  }		 // end incrementSandbags()

	  
			// Decrement sandbags
		  public void decrementSandbags(Context context, String id) {
			  	
			  	this.setId(id);
			  try{
			  	DecrementSandbagAsyncTask task = new DecrementSandbagAsyncTask();
			  	task.execute();

			  	}
			  	catch(BadTokenException e){
			  		e.printStackTrace();
			  	}
			  }
						  
		  private class DecrementSandbagAsyncTask extends AsyncTask<Void, Void, Void> {


				@Override
				protected Void doInBackground(Void... params) {
					
					String url = "http://sondre.mannsverk.no/restful.php?user=" + id +"&sandbags";
					HttpGet getRequest = new HttpGet(url);
					
					try {
						DefaultHttpClient httpClient = new DefaultHttpClient();
						HttpResponse getResponse = httpClient.execute(getRequest);
						
						final int statusCode = getResponse.getStatusLine().getStatusCode();
						
						if (statusCode != HttpStatus.SC_OK) { 
				            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
				        }

					} 
					catch (IOException e) {
						getRequest.abort();
				        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
					}
					try{

				  	}
				  	catch(IllegalArgumentException e){
				  		e.printStackTrace();
				  	}
					return null;
				}
		  }		 // end decrementSandbags()
	  
	
	  // Updates score of a sandbag quest 
		  
		 public void updateSandbagScore(Context context, int questID, int score){
			  
			  setQuestid(questID);
			  setPoints(Integer.toString(score));

			  try{
				  
				  	updateSandbagAsyncTask task = new updateSandbagAsyncTask();
				  	task.execute();
				  	}
				  	catch(BadTokenException e){
				  		e.printStackTrace();
				  	}
		  } 
				private class updateSandbagAsyncTask extends AsyncTask<Void, Void, Void> {
				
				
					@Override
					protected Void doInBackground(Void... params) {
						
						String url = "http://sondre.mannsverk.no/updatequest.php?quest="+getQuestid()+"&finalscore="+getPoints();
						HttpGet getRequest = new HttpGet(url);
						
						try {
							DefaultHttpClient httpClient = new DefaultHttpClient();
							HttpResponse getResponse = httpClient.execute(getRequest);
							
							final int statusCode = getResponse.getStatusLine().getStatusCode();
							
							if (statusCode != HttpStatus.SC_OK) { 
					            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
					        }
				
						} 
						catch (IOException e) {
							getRequest.abort();
					        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
						}						
						return null;
					}
				}		
		  
		  
		// Place a sandbag
	  public void placeSandbag(Context context, Double lng, Double lat, int type, int distancescore) {
		  
		  	this.setLat(Double.toString(lat));
		  	this.setLng(Double.toString(lng));
		  	this.setType(type);
		  	this.setDistance(distancescore);
		  	this.setCurrentContext(context);
		  	PlaceSandbagAsyncTask task = new PlaceSandbagAsyncTask();
		  	task.execute();
		  			
		  }
							  
		  private class PlaceSandbagAsyncTask extends AsyncTask<Void, Void, Void> {


				@Override
				protected Void doInBackground(Void... params) {
					
					String url = "http://sondre.mannsverk.no/updatequest.php?type="+type+"&lat="+lat+"&lng="+lng+"&distance="+distance;
					HttpGet getRequest = new HttpGet(url);
					Log.w("Placing sandbag at " + lng + " " + lat, "Debug");		
					try {
						DefaultHttpClient httpClient = new DefaultHttpClient();
						HttpResponse getResponse = httpClient.execute(getRequest);
						
						final int statusCode = getResponse.getStatusLine().getStatusCode();
						
						if (statusCode != HttpStatus.SC_OK) { 
				            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
				        }

					} 
					catch (IOException e) {
						getRequest.abort();
				        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
					}
		  		    
					return null;
				}
		  }		 // end placeSandbag()
						  
		  
		  // Set quest with given questID to complete
		  
		  	  public void updateQuest(Context context, int questId) {
			  
			  	this.setQuestid(questId);
			  	this.setCurrentContext(context);
			  	
			  	UpdateQuestAsyncTask task = new UpdateQuestAsyncTask();
			  	task.execute();
			  			
			  }
								  
			  private class UpdateQuestAsyncTask extends AsyncTask<Void, Void, Void> {


					@Override
					protected Void doInBackground(Void... params) {
						
						String url = "http://sondre.mannsverk.no/updatequest.php?quest="+getQuestid();
						HttpGet getRequest = new HttpGet(url);		
						try {
							DefaultHttpClient httpClient = new DefaultHttpClient();
							HttpResponse getResponse = httpClient.execute(getRequest);
							
							final int statusCode = getResponse.getStatusLine().getStatusCode();
							
							if (statusCode != HttpStatus.SC_OK) { 
					            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
					        }

						} 
						catch (IOException e) {
							getRequest.abort();
					        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
						}
			  		    
						return null;
					}
			  }	
				 
			  
			  // Set quest with given questID to complete
			  
		  	  public void tutorialFinished(Context context) {
			  
			  	this.setCurrentContext(context);
			  	
			  	TutorialFinishedAsyncTask task = new TutorialFinishedAsyncTask();
			  	task.execute();
			  			
			  }
								  
			  private class TutorialFinishedAsyncTask extends AsyncTask<Void, Void, Void> {


					@Override
					protected Void doInBackground(Void... params) {
						
						String url = "http://sondre.mannsverk.no/session.php?tutorial";
						HttpGet getRequest = new HttpGet(url);		
						try {
							DefaultHttpClient httpClient = new DefaultHttpClient();
							HttpResponse getResponse = httpClient.execute(getRequest);
							
							final int statusCode = getResponse.getStatusLine().getStatusCode();
							
							if (statusCode != HttpStatus.SC_OK) { 
					            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
					        }

						} 
						catch (IOException e) {
							getRequest.abort();
					        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
						}
			  		    
						return null;
					}
			  }	
				 
						  
				  
				  
				  
				  
// send message
public void sendMessage(String playerID, String to, String message){
  
  	this.id = playerID;
  	this.to = to;
  	this.message = message;
  	
  
  	SendMessageAsyncTask task = new SendMessageAsyncTask();
  	task.execute();
  			
  }
					  
  private class SendMessageAsyncTask extends AsyncTask<Void, Void, Void> {


		@Override
		protected Void doInBackground(Void... params) {
			
			String messageFixed = message.replace(" ", "%20");
			String url = "http://sondre.mannsverk.no/sendmessage.php?from=" + id +"&to="+to+"&message="+messageFixed;
			HttpGet getRequest = new HttpGet(url);
			try {
				DefaultHttpClient httpClient = new DefaultHttpClient();
				HttpResponse getResponse = httpClient.execute(getRequest);
				
				final int statusCode = getResponse.getStatusLine().getStatusCode();
				
				if (statusCode != HttpStatus.SC_OK) { 
		            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
		        }

			} 
			catch (IOException e) {
				getRequest.abort();
		        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
			}
  		    
			return null;
		}
  }		 // end send message()
						
		
  
	  
	//send message
	public void sendMessageToAll(String playerID, String message){
	
	this.id = playerID;
	this.message = message;
	
	
	BroadcastMessageAsyncTask task = new BroadcastMessageAsyncTask();
	task.execute();
		
	}
			  
	private class BroadcastMessageAsyncTask extends AsyncTask<Void, Void, Void> {
	
	
	@Override
	protected Void doInBackground(Void... params) {
	
		String messageFixed = message.replace(" ", "%20");
	String url = "http://sondre.mannsverk.no/sendmessage.php?from=" + id +"&toall&message="+messageFixed;
	HttpGet getRequest = new HttpGet(url);
	try {
		DefaultHttpClient httpClient = new DefaultHttpClient();
		HttpResponse getResponse = httpClient.execute(getRequest);
		
		final int statusCode = getResponse.getStatusLine().getStatusCode();
		
		if (statusCode != HttpStatus.SC_OK) { 
	        Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
	    }
	
	} 
	catch (IOException e) {
		getRequest.abort();
	    Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
	}
	  
	return null;
	}
	}		 // end broadcast message()
	  
  
  //add points
		public void addPoints(String playerID, String points){
		 
		 	this.id = playerID;
		 	this.points = points;
		 	
		 
		 	addPointsAsyncTask task = new addPointsAsyncTask();
		 	task.execute();
		 			
		 }
							  
		 private class addPointsAsyncTask extends AsyncTask<Void, Void, Void> {
		
		
				@Override
				protected Void doInBackground(Void... params) {
					
					String url = "http://sondre.mannsverk.no/player.php?player="+id+"&points="+points;
					HttpGet getRequest = new HttpGet(url);
					try {
						DefaultHttpClient httpClient = new DefaultHttpClient();
						HttpResponse getResponse = httpClient.execute(getRequest);
						
						final int statusCode = getResponse.getStatusLine().getStatusCode();
						
						if (statusCode != HttpStatus.SC_OK) { 
				            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
				        }
		
					} 
					catch (IOException e) {
						getRequest.abort();
				        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
					}
		 		    
					return null;
				}
		 }		
								
			public void finishSession(int id){
				 
			 	setSessionid(id);
			 	
			 
			 	finishSessionAsyncTask task = new finishSessionAsyncTask();
			 	task.execute();
			 			
			 }
								  
			 private class finishSessionAsyncTask extends AsyncTask<Void, Void, Void> {
			
			
					@Override
					protected Void doInBackground(Void... params) {
						
						String url = "http://sondre.mannsverk.no/session.php?finish&id="+getSessionid();
						HttpGet getRequest = new HttpGet(url);
						try {
							DefaultHttpClient httpClient = new DefaultHttpClient();
							HttpResponse getResponse = httpClient.execute(getRequest);
							
							final int statusCode = getResponse.getStatusLine().getStatusCode();
							
							if (statusCode != HttpStatus.SC_OK) { 
					            Log.w(getClass().getSimpleName(), "Error " + statusCode + " for URL " + url); 
					        }
			
						} 
						catch (IOException e) {
							getRequest.abort();
					        Log.w(getClass().getSimpleName(), "Error for URL " + url, e);
						}
			 		    
						return null;
					}
			 }								  
							   
}





