package com.flooded.quests;

import java.util.ArrayList;
import java.util.List;

import com.flooded.MapActivity;
import com.flooded.R;
import com.flooded.gameEntities.Session;
import com.flooded.helperClasses.Helper;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.GoogleMap.OnMarkerClickListener;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.location.Location;
import android.util.Log;
import android.widget.TextView;
import android.widget.Toast;


public class Tutorial extends Quest {

	
	Context c;
	AlertDialog welcomeMessage, crateMessage, sandbagMessage, sendMessage;
	protected static LatLng NTNU = new LatLng(63.417125,10.402020);
	protected static LatLng Home = new LatLng(63.430208,10.387959);
	public static int sandbagPickedUp = 1;
	public static int sandbagPlaced = 2;
	public static int messageSent = 3;
	public boolean cratePlaced = false;
	private Intent intent;
	private List<Marker> markers;
	
	LatLng crateLocation;
	
	public Tutorial(GoogleMap map, Context context, String id, Intent i, Session session) {
		super(map, context, id, session);
		this.setId(tutorialQuest);
		crateLocation = Home;
		setQuestDescription("tutorial");
		setSandbags(0);
		markers = new ArrayList<Marker>();
		
		//crateLocation = NTNU;
	}
	
	
	public LatLng getCrateLocation() {
		
		return crateLocation;
	}
	
	public void setCrateLocation(LatLng crateLocation) {
		this.crateLocation = new LatLng(crateLocation.latitude, crateLocation.longitude);
		if(!cratePlaced){
			addNewMarker(crateLocation.latitude, crateLocation.longitude, qCrateText, crateIcon, markers, true);
			addNewMarker(Home.latitude, Home.longitude, qCrateText, crateIcon, markers, true);
			cratePlaced = true;
		}
	}

	public void initQuestSpecific(){

		if(getPhase() == 0 && !cratePlaced){
				setCrateLocation(new LatLng(63.422563,10.396199));
		}
	}
	

	public void initQuestSpecific(LatLng latLng) {
		if(getPhase() == 0 && !cratePlaced){
		addNewMarker(latLng.latitude, latLng.longitude, qCrateText, crateIcon, markers, true);
		cratePlaced = true;
		}
	}


	
	public void initQuest(){	
		
		super.initQuest();
		addMarkerClickListener();
		
		if(getPhase() == 0){
			setStartDialog(showTutorialDialog());
			setSandbags(0);
		} else if(getPhase() == Tutorial.sandbagPickedUp){
			setSandbags(5);
			updateHUD();
			setStartDialog(showSandbagDialog());
		} else if(getPhase() == Tutorial.sandbagPlaced){
			setStartDialog(showSendMessageDialog());
		}
		
		else if(getPhase() == Tutorial.messageSent){
			finishQuest();
		}
		
	}
	
	public Intent getIntent() {
		return intent;
	}
	
	public boolean finishQuest(){

		if(getPhase()==Tutorial.messageSent){
			SharedPreferences settings = getContext().getSharedPreferences(PREFS_NAME, 0);
			SharedPreferences.Editor editor = settings.edit();
			editor.putInt("tutorialPhase", Tutorial.messageSent);
			// Commit the edits!
			editor.commit();
			return true;
		}
		return false;
		
	}
	private void pickUpAction(){
		if(getPhase() == 0){
			Location crateLoc = new Location("");
			crateLoc.setLatitude(getCrateLocation().latitude);
			crateLoc.setLongitude(getCrateLocation().longitude);
			 if(inRangeOfLocation(getMap().getMyLocation(), crateLoc, distanceToCrate) || inRangeOfLocation(getMap().getMyLocation(), Home, distanceToCrate)){
				 if(markers.size() > 0){
		    		  markers.get(0).setVisible(false);
		    		  markers.remove(0);
		    		  setSandbags(getSandbags()+5);
		    		  updateHUD();
		    		  setPhase(Tutorial.sandbagPickedUp);
		    		  showSandbagDialog();
				 }
			 }
			 else {
				 Helper.displayText("You are not close enough to open the crate!", getContext(), false);
			 }
		}
	}
	
	private void placeSandbagAction(Location location){
		
		if(getPhase() == Tutorial.sandbagPickedUp){
			if(getSandbags() > 0){
				try{
					double latitude = location.getLatitude();
					double longitude = location.getLongitude();
					addNewMarker(latitude, longitude, sandbagText, sandbagIcon, markers, true);					
					setSandbags(0);
					setPhase(Tutorial.sandbagPlaced);
					showSendMessageDialog();
				} catch(NullPointerException e){
					e.printStackTrace();
					Log.e("Location not available", "error");
				}
			} else{
				Helper.displayText("You have no sandbags left", getContext(), false);
			}
		} else {
			Helper.displayText("You do not have any sandbags!", getContext(), false);
		}
	}
		
	

	
	 @Override
	public void interact() {
		 placeSandbagAction(getMap().getMyLocation());
		 updateHUD();
	}
	 
	
	
    // Show dialog for choosing a quest
	public AlertDialog showTutorialDialog(){
	      
		welcomeMessage = new AlertDialog.Builder(getContext())
	          .setTitle("Welcome")
	          .setMessage("Welcome, new volunteer! To get started, you will be given a few simple tasks." +
	          		" By completing them you may rise in the ranks, and be given more difficult challenges!")
	          .setPositiveButton("OK", new DialogInterface.OnClickListener() {
	                   public void onClick(DialogInterface dialog, int id) {
	                	   showCrateDialog();
	                   }}).show();
		return welcomeMessage;
	
	      
 } // end showOptionsDialog
	

	public AlertDialog showCrateDialog(){
		crateMessage = new AlertDialog.Builder(getContext())
         .setTitle("Pick up a sandbag")
         .setMessage("Crates contain sandbags that you can pick up! " +
         		"Walk to the crate icon on the map. When you reach the destination, pick up the sandbags within by using" +
         		" the 'Pick up'-button in the action menu.")
         .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                  public void onClick(DialogInterface dialog, int id) {
                  }}).show();
		return crateMessage;
	}
	
	 // Show dialog for choosing a quest
		public AlertDialog showSandbagDialog(){
		      sandbagMessage = new AlertDialog.Builder(getContext())
		         .setTitle("Place a wall of sandbags")
    	          .setMessage("Sandbags are used to protect areas against floods. " +
    	          		"By placing sandbags, the impact of the flood can be reduced. " +
    	          		" Try placing a wall of sandbags on the map by using the 'Place sandbags'-button." +
    	          		" Each wall requires 5 sandbags.")
		          .setPositiveButton("OK", new DialogInterface.OnClickListener() {
			        	  public void onClick(DialogInterface dialog, int id) {
						}}).show();
		      return sandbagMessage;
	 } // end showOptionsDialog
	
		
		 // Show dialog for sending a message
			public AlertDialog showSendMessageDialog(){
			      sendMessage = new AlertDialog.Builder(getContext())
			         .setTitle("Send a message")
	    	          .setMessage("Collaboration with others is essential to complete your challenges. " +
	    	          		"Other players can be seen as a green dot on the map. You can send private messages to your Facebook-friends. You can also broadcast messages to everyone. "  +
	    	          		"Click the 'Messages'-button and send a message to a friend to complete the task. ")
			          .setPositiveButton("OK", new DialogInterface.OnClickListener() {
				        	  public void onClick(DialogInterface dialog, int id) {
							}}).show();
			      return sendMessage;
		 } // end sendMessageDialog

			private void addMarkerClickListener(){
				getMap().setOnMarkerClickListener(new OnMarkerClickListener() {
					
					@Override
					public boolean onMarkerClick(Marker marker) {
						if(marker.getTitle().equals(qCrateText)){
							pickUpAction();
						}
						return false;
					}
				});
			}
			
		
			
	

}
